Package: readapra
Title: Download and Tidy Data from the Australian Prudential Regulation
        Authority
Version: 0.2.3
Authors@R: 
    person(given = "Jarrod", 
           family = "van der Wal", 
           email = "jarvanderwal@gmail.com",
           role = c("aut", "cre", "cph")
           )
Description: Download the latest data from the Australian Prudential Regulation
    Authority <https://www.apra.gov.au/> and import it into R as a tidy data 
    frame. 
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: openxlsx, readr, testthat (>= 3.0.0), webmockr, withr
Config/testthat/edition: 3
URL: https://github.com/javanderwal/readapra,
        https://javanderwal.github.io/readapra/
BugReports: https://github.com/javanderwal/readapra/issues
Imports: cli (>= 3.0.0), dplyr (>= 1.0.0), httr (>= 1.0.0), janitor,
        lubridate (>= 1.0.0), purrr (>= 1.0.0), rlang (>= 1.0.0), rvest
        (>= 1.0.0), stringdist, stringr (>= 1.0.0), tibble (>= 2.0.0),
        tidyr (>= 1.0.0), tidyselect (>= 1.0.0), tidyxl (>= 1.0.0),
        utils, xml2
Depends: R (>= 3.5)
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2026-05-03 00:04:39 UTC; jarva
Author: Jarrod van der Wal [aut, cre, cph]
Maintainer: Jarrod van der Wal <jarvanderwal@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-03 05:10:02 UTC
Built: R 4.6.0; ; 2026-05-03 09:03:32 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

<img src="reference/figures/readapra_hex_sticker.png" align="right" style="max-height: 139px; width: auto;">

<!-- badges: start -->

[![Codecov test
coverage](https://codecov.io/gh/javanderwal/readapra/graph/badge.svg)](https://app.codecov.io/gh/javanderwal/readapra)
[![R-CMD-check](https://github.com/javanderwal/readapra/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/javanderwal/readapra/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

The R package `readapra` provides a series of function to download and
import data from the [Australian Prudential Regulation Authority’s
(APRA)](https://www.apra.gov.au/) statistical publications and return
them as a [tibble](https://tibble.tidyverse.org/) object.

## Installation

You can install `readapra` from CRAN using:

``` r
install.packages("readapra")
```

Or you can install the development version from GitHub using the
[`remotes`](https://remotes.r-lib.org/) package:

``` r
remotes::install_github("javanderwal/readapra")
```

## Features

The `readapra` package facilitates the downloading and importing of
statistical publications published by APRA. The package also allows for
the importing of data from locally saved statistical publication files.

Currently the `readapra` package only supports the downloading and
importing of Authorised Deposit-taking Institution (ADI) statistical
publications. The intention is for future versions of `readapra` to also
accommodate APRA’s general insurance, life insurance and friendly
societies, private health insurance and superannuation statistical
publications.

#### ADI statistical publications

The following ADI statistical publications can be downloaded and
imported with `readapra`:

- [Quarterly Authorised Deposit-taking Institution Performance
  Statistics
  (QADIPS)](https://www.apra.gov.au/quarterly-authorised-deposit-taking-institution-statistics)

- [Quarterly Authorised Deposit-taking Institution Centralised
  Publication
  (QADICP)](https://www.apra.gov.au/quarterly-authorised-deposit-taking-institution-statistics)

- [Quarterly Authorised Deposit-taking Institution Property Exposures
  Statistics
  (QADIPEXS)](https://www.apra.gov.au/quarterly-authorised-deposit-taking-institution-statistics)
  (both the current and historic series)

- [Monthly Authorised Deposit- taking Institution Statistics
  (MADIS)](https://www.apra.gov.au/monthly-authorised-deposit-taking-institution-statistics)
  (both the current and historic series)

- [Authorised Deposit-taking Institution Points of Presence Statistics
  (ADIPOPS)](https://www.apra.gov.au/authorised-deposit-taking-institutions-points-of-presence-statistics)

## Example

The ability to download and import APRA’s statistical publications with
`readapra` greatly eases the analysis and visualisation of this data via
packages such as `ggplot2`.

The following example demonstrates the plotting of total resident assets
on a monthly basis for Australia’s four major banks.

We start by first librarying the required packages:

``` r
library(readapra)
library(tidyverse)
```

We then download and import the Monthly Authorised Deposit-taking
Institution Statistics (MADIS) data using the `read_apra()` function:

``` r
madis_data <- read_apra(stat_pub = "madis", cur_hist = "current")
```

We then filter and clean-up the desired data like so:

``` r
major_bank_assets <- 
  madis_data %>%
  filter(
    abn %in% c(48123123124, 33007457141, 12004044937, 11005357522),
    series == "Total residents loans and finance leases"
  ) %>%
  mutate(
    short_name = dplyr::case_when(
      abn == 48123123124 ~ "CBA",
      abn == 33007457141 ~ "WBC",
      abn == 12004044937 ~ "NAB",
      abn == 11005357522 ~ "ANZ",
    )
  ) %>%
  group_by(short_name) %>%
  mutate(value = 100 * value / first(value)) %>%
  ungroup()
```

And then finally we can plot the data using `ggplot2`:

``` r
ggplot(
  data = major_bank_assets,
  mapping = aes(date, value, colour = short_name)
) +
  geom_line(linewidth = 1) +
  labs(
    title = "Major Australian Banks' Total Resident Loans and Finance Leases",
    subtitle = "Indexed to March 2019",
    caption = "Source: APRA"
  ) +
  theme_bw() +
  theme(
    plot.title = element_text(face = "bold"),
    legend.position = "top",
    legend.title = element_blank(),
    axis.title = element_blank(),
    axis.text = element_text(colour = "black") 
  ) +
  scale_colour_manual(values = c(
    "CBA" = "#FECA0A",
    "WBC" = "#DF0000",
    "NAB" = "#000000",
    "ANZ" = "#009FE1"
  ))
```

<img src="man/figures/README-plot_madis-1.svg" width="100%" style="display: block; margin: auto;" />

## Managing Network Connections

Corporate networks, especially those using Virtual Private Networks
(VPNs), may restrict the ability to download files within an R session.
A possible fix for this is to utilise the the `"wininet"` method for
downloading files. Users can specify the `"wininet"` method (or any
other download method) for `readapra` to use by setting the
`"R_READAPRA_DL_METHOD"` environment variable.

To set the `"R_READAPRA_DL_METHOD"` environment variable to `"wininet"`
for your current session, use the following code:

``` r
Sys.setenv("R_READAPRA_DL_METHOD" = "wininet")
```

You can add `"R_READAPRA_DL_METHOD" = "wininet"` to your `.Renviron`
file to ensure this download setting persists across R sessions. You can
conveniently access and edit your `.Renviron` file with the
[`usethis`](https://usethis.r-lib.org/) package:

``` r
usethis::edit_r_environ()
```

## Disclaimer

This package is not affiliated with or endorsed by the Australian
Prudential Regulation Authority (APRA). All data is provided subject to
any conditions and restrictions set out on the APRA website.

#' Read APRA's Statistical Publications
#'
#' @description
#' Download and import a specific statistical publication produced by APRA.
#'
#' Please consult the [apra_stat_pubs] dataset to see which of APRA's
#' statistical publications are available in `readapra`.
#'
#' @param stat_pub character vector detailing a statistical publication to be
#' downloaded and imported. Must match a valid value in the
#' `apra_stat_pubs_acronym` variable of the [apra_stat_pubs] dataset.
#' @param cur_hist character vector detailing whether to download and import
#' a current or historic statistical publication. Must match a
#' valid value in the `cur_hist` variable of the [apra_stat_pubs]
#' dataset.
#' @param path path to where the downloaded file should be saved. Uses
#' [base::tempdir()] by default.
#' @param overwrite whether to overwrite a previously downloaded statistical
#' publication file when re-running this function.
#' @param quiet whether to suppress the download progress bar.
#' @param ... additional arguments to be passed to [utils::download.file()].
#'
#' @return A tibble containing the statistical publication data.
#' @export
#'
#' @examples
#' \donttest{
#' # Download and import the current MADIS data:
#' current_madis_data <-
#'   read_apra(stat_pub = "madis", cur_hist = "current")
#'
#' # Examine the current MADIS data:
#' print(current_madis_data)
#' }
#'
read_apra <- function(stat_pub,
                      cur_hist = "current",
                      path = tempdir(),
                      quiet = FALSE,
                      overwrite = TRUE,
                      ...) {
  temp_file_path <-
    download_apra_with_caller(
      stat_pub = stat_pub,
      cur_hist = cur_hist,
      path = path,
      quiet = quiet,
      overwrite = overwrite,
      ...
    )

  read_apra_local(temp_file_path, stat_pub, cur_hist)
}

#' Read APRA Publication Statistics Locally
#'
#' @description
#' Import from a local file a specific statistical publication produced by APRA.
#'
#' Please consult the [apra_stat_pubs] dataset to see which of APRA's
#' statistical publications are available in `readapra`.
#'
#' @param file_path path to the local file from which the statistical
#' publication data will be imported.
#' @param stat_pub character vector detailing a statistical publication to be
#' imported. Must match a valid value in the `apra_stat_pubs_acronym` variable
#' of the [apra_stat_pubs] dataset.
#' @param cur_hist character vector detailing whether to import a current
#' or historic statistical publication. Must match a
#' valid value in the `cur_hist` variable of the [apra_stat_pubs]
#' dataset.
#'
#' @return A tibble containing the statistical publication data.
#' @export
#'
#' @examples
#' \donttest{
#' # Download the current MADIS data and get the file path:
#' current_madis_file_path <-
#'   download_apra(stat_pub = "madis", cur_hist = "current")
#'
#' # Import the current MADIS data:
#' current_madis_data <-
#'   read_apra_local(
#'     stat_pub = "madis",
#'     cur_hist = "current",
#'     file_path = current_madis_file_path
#'   )
#'
#' # Examine the current MADIS data:
#' print(current_madis_data)
#' }
#'
read_apra_local <- function(file_path,
                            stat_pub,
                            cur_hist = "current") {
  check_valid_file_path(file_path)

  matched_fn_name <-
    check_standard_user_inputs(stat_pub, cur_hist)$read_function

  if (length(matched_fn_name) != 1) {
    cli::cli_abort(
      message = "Could not read local file. Couldn't determine correct function to use.",
      class = "readapra_error_multiple_functions_in_read_apra_local"
    )
  }

  read_fn <-
    rlang::as_function(
      x = matched_fn_name,
      env = asNamespace("readapra")
    )

  read_fn(file_path, cur_hist)
}

test_that("read_apra() behaves as expected", {
  skip_if_offline()
  skip_on_cran()

  expect_no_error(
    qadips_data <- read_apra("qadips", "current", quiet = TRUE)
  )

  expect_s3_class(qadips_data, "tbl")
})

test_that("read_apra_local() behaves as expected", {
  skip_if_offline()
  skip_on_cran()

  expect_no_error(
    qadips_data <- read_apra_local(
      file_path = download_apra("qadips", "current", quiet = TRUE),
      stat_pub = "qadips",
      cur_hist = "current"
    )
  )

  expect_s3_class(qadips_data, "tbl")
})

test_that("read_apra() error snapshots", {
  # Misspelled stat_pub input
  testthat::expect_snapshot(
    {
      read_apra(stat_pub = "madi", cur_hist = "current")
    },
    error = TRUE
  )

  # stat_pub is wrong object type
  testthat::expect_snapshot(
    {
      read_apra(stat_pub = data.frame(), cur_hist = "current")
    },
    error = TRUE
  )

  # stat_pub is wrong vector type
  testthat::expect_snapshot(
    {
      read_apra(stat_pub = 1:5, cur_hist = "current")
    },
    error = TRUE
  )

  # stat_pub is wrong length
  testthat::expect_snapshot(
    {
      read_apra(stat_pub = c("madis", "current"), cur_hist = "current")
    },
    error = TRUE
  )

  # Misspelled cur_hist input
  testthat::expect_snapshot(
    {
      read_apra(stat_pub = "madi", cur_hist = "curren")
    },
    error = TRUE
  )

  # cur_hist is wrong object type
  testthat::expect_snapshot(
    {
      read_apra(stat_pub = "madis", cur_hist = data.frame())
    },
    error = TRUE
  )

  # cur_hist is wrong vector type
  testthat::expect_snapshot(
    {
      read_apra(stat_pub = "madis", cur_hist = 1:5)
    },
    error = TRUE
  )

  # cur_hist is wrong length
  testthat::expect_snapshot(
    {
      read_apra(stat_pub = "madis", cur_hist = c("current", "historic"))
    },
    error = TRUE
  )

  # quiet is wrong object type
  testthat::expect_snapshot(
    {
      read_apra(
        stat_pub = "madis",
        cur_hist = "current",
        quiet = data.frame()
      )
    },
    error = TRUE
  )

  # quiet is wrong vector type
  testthat::expect_snapshot(
    {
      read_apra(
        stat_pub = "madis",
        cur_hist = "current",
        quiet = "TRUE"
      )
    },
    error = TRUE
  )

  # quiet is wrong length
  testthat::expect_snapshot(
    {
      read_apra(
        stat_pub = "madis",
        cur_hist = "current",
        quiet = c(TRUE, TRUE)
      )
    },
    error = TRUE
  )

  # overwrite is wrong object type
  testthat::expect_snapshot(
    {
      read_apra(
        stat_pub = "madis",
        cur_hist = "current",
        overwrite = data.frame()
      )
    },
    error = TRUE
  )

  # overwrite is wrong vector type
  testthat::expect_snapshot(
    {
      read_apra(
        stat_pub = "madis",
        cur_hist = "current",
        overwrite = "TRUE"
      )
    },
    error = TRUE
  )

  # overwrite is wrong length
  testthat::expect_snapshot(
    {
      read_apra(
        stat_pub = "madis",
        cur_hist = "current",
        overwrite = c(TRUE, TRUE)
      )
    },
    error = TRUE
  )
})

test_that("read_apra() errors are correct class", {
  # Misspelled stat_pub input
  expect_error(
    read_apra(stat_pub = "madi", cur_hist = "current"),
    class = "readapra_error_invalid_stat_pub_input"
  )

  # stat_pub is wrong object type
  expect_error(
    read_apra(stat_pub = data.frame(), cur_hist = "current"),
    class = "readapra_error_input_arg_not_vector"
  )

  # stat_pub is wrong vector type
  expect_error(
    read_apra(stat_pub = 1:5, cur_hist = "current"),
    class = "readapra_error_input_arg_not_character"
  )

  # stat_pub is wrong length
  expect_error(
    read_apra(stat_pub = c("madis", "current"), cur_hist = "current"),
    class = "readapra_error_input_arg_not_length_1"
  )

  # Misspelled cur_hist input
  expect_error(
    read_apra(stat_pub = "madis", cur_hist = "curren"),
    class = "readapra_error_invalid_cur_hist_input"
  )

  # cur_hist is wrong object type
  expect_error(
    read_apra(stat_pub = "madis", cur_hist = data.frame()),
    class = "readapra_error_input_arg_not_vector"
  )

  # cur_hist is wrong vector type
  expect_error(
    read_apra(stat_pub = "madis", cur_hist = 1:5),
    class = "readapra_error_input_arg_not_character"
  )

  # cur_hist is wrong length
  expect_error(
    read_apra(stat_pub = "madis", cur_hist = c("current", "historic")),
    class = "readapra_error_input_arg_not_length_1"
  )

  # quiet is wrong object type
  expect_error(
    read_apra(
      stat_pub = "madis",
      cur_hist = "current",
      quiet = data.frame()
    ),
    class = "readapra_error_input_arg_not_vector"
  )

  # quiet is wrong vector type
  expect_error(
    read_apra(
      stat_pub = "madis",
      cur_hist = "current",
      quiet = "TRUE"
    ),
    class = "readapra_error_input_arg_not_logical"
  )

  # quiet is wrong length
  expect_error(
    read_apra(
      stat_pub = "madis",
      cur_hist = "current",
      quiet = c(TRUE, TRUE)
    ),
    class = "readapra_error_input_arg_not_length_1"
  )

  # overwrite is wrong object type
  expect_error(
    read_apra(
      stat_pub = "madis",
      cur_hist = "current",
      overwrite = data.frame()
    ),
    class = "readapra_error_input_arg_not_vector"
  )

  # overwrite is wrong vector type
  expect_error(
    read_apra(
      stat_pub = "madis",
      cur_hist = "current",
      overwrite = "TRUE"
    ),
    class = "readapra_error_input_arg_not_logical"
  )

  # overwrite is wrong length
  expect_error(
    read_apra(
      stat_pub = "madis",
      cur_hist = "current",
      overwrite = c(TRUE, TRUE)
    ),
    class = "readapra_error_input_arg_not_length_1"
  )
})

test_that("read_apra_local() error snapshots", {
  # Skip due to divergence across OS systems.
  skip_on_os(c("mac", "linux", "solaris"))

  # Invalid file_path
  testthat::expect_snapshot(
    {
      read_apra_local(
        file_path = "C:/Users/test_user/test_file.xlsx",
        stat_pub = "madi",
        cur_hist = "current"
      )
    },
    error = TRUE
  )
})

test_that("read_apra_local_local() errors are correct class", {
  # Invalid file_path
  expect_error(
    read_apra_local(
      file_path = "C:/Users/test_user/test_file.xlsx",
      stat_pub = "madi",
      cur_hist = "current"
    ),
    class = "read_apra_error_file_path_does_not_exist"
  )
})

tidyxl_data <-
  tidyxl::xlsx_cells(test_path("test_data", "horizontal_test_data.xlsx"),
    include_blank_cells = FALSE
  )

formatting_data <-
  tidyxl::xlsx_formats(test_path("test_data", "horizontal_test_data.xlsx"))

formatting_data <- list(local = formatting_data$local)

saveRDS(
  object = tibble::lst(tidyxl_data, formatting_data),
  file = test_path("test_data", "horizontal_test_data.rds")
)

#' Read ADI Points of Presence Statistics
#'
#' @description
#' Import the Authorised Deposit-taking Institution Points of Presence
#' Read ADI Points of Presence Statistics from a local file.
#'
#' @param file_path path to the local .xlsx file.
#' @param cur_hist character vector determining whether to download the current
#' publication (`"current"`) or the historic publication (`"historic"`).
#'
#' @return A tibble containing the ADI Points of Presence Statistics data.
#'
#' @noRd
#'
read_adipops <- function(file_path, cur_hist, call = rlang::caller_env()) {
  tidyxl_data <- read_tidyxl_data(file_path, sheets = "table.*1", call = call)
  formatting_data <- read_tidyxl_formatting_data(file_path)
  adipops_data(tidyxl_data, formatting_data, call = call)
}

#' Extracts the ADIPOPS data and cleans it.
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#'
#' @noRd
#'
adipops_data <- function(tidyxl_data,
                         formatting_data,
                         call = rlang::caller_env()) {
  adipops_data <-
    attempt_format_vertical_data(
      tidyxl_data = tidyxl_data,
      formatting_data = formatting_data,
      stat_pub_name = "Authorised Deposit-taking Institutions' Points of Presence Statistics",
      frequency = "Quarterly",
      call = call
    )
  adipops_data <- convert_adipops_units(adipops_data)
  adipops_data <- convert_abn(adipops_data)
  adipops_data <-
    dplyr::arrange(
      .data = adipops_data,
      date,
      institution_name,
      service_channel_type,
      sa4_name,
      sa3_name,
      sa2_name
    )

  return(adipops_data)
}

#' Cleans up the units column in the ADIPOPS data so it matches other publications.
#'
#' @param data the ADIPOPS data to be cleaned.
#'
#' @noRd
#'
convert_adipops_units <- function(data) {
  adipops_correct_units <-
    dplyr::mutate(
      .data = data,
      unit = dplyr::case_when(
        stringr::str_detect(
          string = series,
          pattern = stringr::regex("number", ignore_case = TRUE)
        ) ~ unit,
        .default = series
      )
    )
  return(adipops_correct_units)
}

test_that("read_adipops() real download", {
  skip_if_offline()
  skip_on_cran()

  with_tempdir({
    adipos_path <- download_apra("adipops", "current", quiet = TRUE)
    adipops <- read_adipops(adipos_path, "current")
    expect_s3_class(adipops, "tbl_df")
    expect_equal(
      purrr::map(adipops, class),
      list(
        statistics_publication_name = "character",
        date = "Date",
        sector = "character",
        abn = "numeric",
        institution_name = "character",
        service_channel_type = "character",
        states_and_territories = "character",
        sa4_name = "character",
        sa3_name = "character",
        sa2_name = "character",
        suburb_or_locality = "character",
        remoteness = "character",
        series = "character",
        frequency = "character",
        unit = "character",
        value = "numeric"
      )
    )
  })
})

test_that("convert_adipops_units() behaves as expected", {
  input_data <-
    tibble::tibble(
      stat_pub = "ADIPOPS",
      date = as.Date("2024-12-31"),
      test_field = paste("field", sort(rep(1:4, 3))),
      series = rep(c("Latitude", "Longitude", "Number"), 4),
      unit = rep(c("$ million", "$ million", "No."), 4),
      value = rnorm(12)
    )

  output_data <- input_data
  output_data$unit <- rep(c("Latitude", "Longitude", "No."), 4)

  expect_equal(
    convert_adipops_units(input_data),
    output_data
  )
})

#' @keywords internal
"_PACKAGE"

utils::globalVariables(c(
  "balance_sheet_category", "series", "risk_metric_category",
  "sheet_details", "sheet", "data_type", "series_hierarchy",
  "unit", "value", "error", "local_format_id", "statistics_publication_name",
  "indent", "measure_type", "stat_pub_acronym", "count", "institution_name",
  "service_channel_type", "sa4_name", "sa3_name", "sa2_name", "entity", "abn"
))

#' Takes a vector of URLs and tries to identify the URL to use as a download
#' link use the filtered URL from the apra_stat_pubs_details data
#'
#' @param urls_to_check a vector of URLs from which the correct on needs to be
#' extracted
#' @param selected_stat_pub the filtered apra_stat_pubs_details containing the
#' required URL
#' @param call caller environment for error message handling
#'
#' @noRd
#'
url_selector <- function(urls_to_check,
                         selected_stat_pub,
                         call = rlang::caller_env()) {
  regex_matched_url <-
    stringr::str_subset(
      urls_to_check,
      selected_stat_pub$regex_link
    )

  if (length(regex_matched_url) == 1) {
    return(regex_matched_url)
  }

  file_to_find <- prepare_name_comparison(selected_stat_pub$file_name)
  files_to_compare <- prepare_name_comparison(basename(urls_to_check))

  if (length(files_to_compare) < 1 | length(file_to_find) != 1) {
    cli::cli_abort(
      message = "Could not determine correct URL to download.",
      class = "readapra_could_not_find_right_file_url",
      call = call
    )
  }

  stringdist_match_result <-
    stringdist::amatch(
      x = file_to_find,
      table = files_to_compare,
      method = "jw",
      maxDist = Inf
    )

  return(urls_to_check[stringdist_match_result])
}

#' Take an encoded file name and cleans it by removing and months or numbers
#' in the string
#'
#' @param url the url to prepare for a name comparison
#'
#' @noRd
#'
prepare_name_comparison <- function(url) {
  decoded_url <- utils::URLdecode(url)

  month_pattern <-
    paste0("\\b(", paste(c(month.name, month.abb), collapse = "|"), ")\\b")

  url_no_month <-
    stringr::str_remove_all(
      string = decoded_url,
      pattern = stringr::regex(month_pattern, ignore_case = TRUE)
    )

  url_no_numbers <- stringr::str_remove_all(url_no_month, "\\d+")

  url_no_whitespace <- stringr::str_trim(url_no_numbers)

  return(url_no_whitespace)
}

test_that("url_selector() behaves as expected", {
  input_urls_to_check <-
    c(
      "#main-content",
      "https://www.apra.gov.au/",
      "https://www.apra.gov.au/news-and-publications?industry%5B2%5D=2",
      "https://www.apra.gov.au/sites/default/files/2024-10/20241031%20-%20Monthly%20authorised%20deposit-taking%20institution%20statistics%20back-series%20March%202019%20-%20September%202024.xlsx",
      "https://www.apra.gov.au/sites/default/files/monthly_banking_statistics_june_2019_back_series.xlsx",
      "https://www.apra.gov.au/sites/default/files/2024-09/20240912%20-%20Quarterly%20authorised%20deposit-taking%20institution%20performance%20statistics%20-%20September%202004%20to%20June%202024.xlsx",
      "https://www.apra.gov.au/sites/default/files/2024-09/20240912%20-%20Quarterly%20authorised%20deposit-taking%20institution%20property%20exposures%20statistics%20-%20September%202004%20to%20June%202024.xlsx",
      "https://www.apra.gov.au/sites/default/files/2020-03/Quarterly%20authorised%20deposit-taking%20institution%20property%20exposures%20-%20Historical%20data.xlsx",
      "https://www.apra.gov.au/sites/default/files/2024-09/20240912%20-%20Authorised%20deposit-taking%20institution%20centralised%20publication%20-%20March%202013%20to%20June%202024_0.xlsx",
      "https://www.apra.gov.au/sites/default/files/2024-10/20241016%20-%20Authorised%20deposit-taking%20institutions%20points%20of%20presence%20June%202017%20to%20June%202024.xlsx"
    )

  input_selected_stat_pub <-
    dplyr::filter(
      .data = apra_stat_pubs_details,
      stat_pub_acronym == "madis", cur_hist == "current"
    )

  # Regex behaves as expected
  expect_equal(
    url_selector(input_urls_to_check, input_selected_stat_pub),
    input_urls_to_check[4]
  )

  # Stringdist accounts for minor spelling error
  input_urls_to_check[4] <- "https://www.apra.gov.au/sites/default/files/2024-10/20241031%20-%20Month%20authorised%20deposi-taking%20instiution%20%20back-series%20March%202019%20-%20September%202024.xlsx"
  expect_equal(
    url_selector(input_urls_to_check, input_selected_stat_pub),
    input_urls_to_check[4]
  )
})

test_that("url_selector() errors correctly", {
  input_selected_stat_pub <-
    dplyr::filter(
      .data = apra_stat_pubs_details,
      stat_pub_acronym == "madis", cur_hist == "current"
    )

  expect_error(
    url_selector(
      urls_to_check = character(),
      selected_stat_pub = input_selected_stat_pub
    ),
    regexp = "Could not determine correct URL to download.",
    class = "readapra_could_not_find_right_file_url"
  )
})

test_that("prepare_name_comparison() behaves as expected", {
  expect_equal(
    prepare_name_comparison("20241212%20-%20Quarterly%20authorised%20deposit-taking%20institution%20performance-September%202004%20to%20September%202024.xlsx"),
    "- Quarterly authorised deposit-taking institution performance-  to  .xlsx"
  )
})

#' Check whether the publication statistics and cur_hist inputs are a valid.
#'
#' @param stat_pub character vector detailing the publication statistics to be
#' checked as valid.
#' @param cur_hist character vector detailing the cur_hist availability to be
#' checked.
#' @param call the caller environment.
#'
#' @noRd
#'
check_standard_user_inputs <- function(stat_pub,
                                       cur_hist,
                                       pub_stats_arg = rlang::caller_arg(stat_pub),
                                       cur_hist_arg = rlang::caller_arg(cur_hist),
                                       call = rlang::caller_env()) {
  check_character_length_one(stat_pub, call = call)
  check_character_length_one(cur_hist, call = call)

  unique_stat_pubs <- unique(apra_stat_pubs_details$stat_pub_acronym)

  if (!stat_pub %in% unique_stat_pubs) {
    best_match_stat_pub <-
      stringdist::amatch(
        x = stat_pub,
        table = unique_stat_pubs,
        method = "dl",
        nomatch = 0,
        maxDist = 3
      )

    cli::cli_abort(
      message = c(
        "{.arg {pub_stats_arg}} must be an acronym of a statistical publication, not {.val {stat_pub}}.",
        if (best_match_stat_pub != 0) c("i" = "Did you mean {.val {unique_stat_pubs[best_match_stat_pub]}}?"),
        "i" = "A list of valid acronyms is available in the {.code apra_stat_pubs} dataset."
      ),
      class = "readapra_error_invalid_stat_pub_input",
      call = call
    )
  }

  stat_pub_rows <-
    dplyr::filter(.data = apra_stat_pubs_details, stat_pub_acronym == stat_pub)

  if (!cur_hist %in% stat_pub_rows$cur_hist) {
    best_match_cur_hist <-
      stringdist::amatch(
        x = cur_hist,
        table = stat_pub_rows$cur_hist,
        method = "dl",
        nomatch = 0,
        maxDist = 3
      )

    cli::cli_abort(
      message = c(
        "{.arg {cur_hist_arg}} must be equal to {.or {.val {stat_pub_rows$cur_hist}}}, not {.val {cur_hist}}.",
        if (best_match_cur_hist != 0) c("i" = "Did you mean {.val {stat_pub_rows$cur_hist[best_match_cur_hist]}}?")
      ),
      class = "readapra_error_invalid_cur_hist_input",
      call = call
    )
  }

  stat_pub_selected <-
    dplyr::filter(.data = stat_pub_rows, cur_hist == {{ cur_hist }})

  if (nrow(stat_pub_selected) != 1) {
    cli::cli_abort(
      message = "Could not determine selected statistical publication based on argument inputs.",
      class = "readapra_error_could_not_select_stat_pub",
      call = call
    )
  }

  return(stat_pub_selected)
}

test_that("check_standard_user_inputs() behaves as expected", {
  # Expect success
  expect_equal(
    check_standard_user_inputs("madis", "historic"),
    dplyr::filter(
      .data = apra_stat_pubs_details,
      stat_pub_acronym == "madis",
      cur_hist == "historic"
    )
  )

  # Expect success
  expect_equal(
    check_standard_user_inputs("qadipexs", "current"),
    dplyr::filter(
      .data = apra_stat_pubs_details,
      stat_pub_acronym == "qadipexs",
      cur_hist == "current"
    )
  )

  # Error if invalid stat_pub input
  expect_error(
    check_standard_user_inputs("madisa", "historical"),
    class = "readapra_error_invalid_stat_pub_input"
  )

  # Error if invalid cur_hist input
  expect_error(
    check_standard_user_inputs("qadips", "historical"),
    class = "readapra_error_invalid_cur_hist_input"
  )
})

test_that("check_character_length_one() behaves as expected", {
  # Error if arg not vector
  expect_error(
    check_character_length_one(data.frame()),
    class = "readapra_error_input_arg_not_vector"
  )

  # Error if arg is not character vector
  expect_error(
    check_character_length_one(numeric()),
    class = "readapra_error_input_arg_not_character"
  )

  # Error if arg is not character vector of length 1.
  expect_error(
    check_character_length_one(c("test_a", "test_b", "test_c")),
    class = "readapra_error_input_arg_not_length_1"
  )
})

convert_test_data_date <- function(data, date_col) {
  col <- rlang::ensym(date_col)
  data[[col]] <-
    as.Date(
      lubridate::parse_date_time(
        x = data[[col]],
        orders = c("ymd", "dmy")
      )
    )
  return(data)
}

vertical_data_input <- function() {
  convert_test_data_date(
    readr::read_csv(
      test_path("test_data", "vertical_data_input.csv"),
      show_col_types = FALSE
    ),
    date
  )
}

vertical_formatting_input <- function() {
  list(local = list(numFmt = c("General", "mm-dd-yy", "0.0%", "General")))
}

vertical_data_output <- function() {
  convert_test_data_date(
    readr::read_csv(
      test_path("test_data", "vertical_data_output.csv"),
      show_col_types = FALSE
    ),
    date
  )
}

data_below_top_row_input <- function() {
  convert_test_data_date(
    readr::read_csv(
      test_path("test_data", "data_below_top_row_input.csv"),
      show_col_types = FALSE
    ),
    date
  )
}

clean_col_names_output <- function() {
  convert_test_data_date(
    readr::read_csv(
      test_path("test_data", "clean_col_names_output.csv"),
      show_col_types = FALSE
    ),
    date
  )
}

clean_col_names_input <- function() {
  data <-
    convert_test_data_date(
      readr::read_csv(
        test_path("test_data", "clean_col_names_input.csv"),
        show_col_types = FALSE,
      ),
      Period_1
    )
  data$series <-
    dplyr::if_else(
      data$series == "Field: \\r\\n Very messy regex_17",
      "Field: \r\n Very messy regex_17",
      data$series
    )
  data
}

existing_cols_input <- function() 1:8

row_names_input <- function() {
  tibble::tribble(
    ~col, ~data_type, ~character,
    1L, "character", "Period",
    2L, "character", "ABN",
    3L, "character", "Entity",
    4L, "character", "Field 1",
    5L, "character", "Field 2",
    6L, "character", "Field 3",
    7L, "character", "Field 4",
    8L, "character", "Field 5"
  )
}

restructure_as_in_xlsx_output <- function() {
  convert_test_data_date(
    readr::read_csv(
      test_path("test_data", "restructure_as_in_xlsx_output.csv"),
      show_col_types = FALSE
    ),
    Period_1
  )
}

get_extra_meta_data_output <- function() {
  tibble::tribble(
    ~series, ~col, ~unit, ~statistics_publication_name, ~frequency,
    "Period", 1L, "$ million", "Test name", "Test frequency",
    "ABN", 2L, "$ million", "Test name", "Test frequency",
    "Entity", 3L, "$ million", "Test name", "Test frequency",
    "Field 1", 4L, "Percent", "Test name", "Test frequency",
    "Field 2", 5L, "$ million", "Test name", "Test frequency",
    "Field 3", 6L, "$ million", "Test name", "Test frequency",
    "Field 4", 7L, "$ million", "Test name", "Test frequency",
    "Field 5", 8L, "Percent", "Test name", "Test frequency"
  )
}

iterate_series_hierarchy_input <- function() {
  readr::read_csv(test_path("test_data", "iterate_series_hierarchy_input.csv"),
    show_col_types = FALSE
  )
}

tidyxl_data_input <- function() {
  readRDS(test_path("test_data", "horizontal_test_data.rds"))$tidyxl_data
}

formatting_data_input <- function() {
  readRDS(test_path("test_data", "horizontal_test_data.rds"))$formatting_data
}

get_series_hierarchy_output <- function() {
  readr::read_csv(test_path("test_data", "get_series_hierarchy_output.csv"),
    show_col_types = FALSE
  )
}

format_horizontal_data_table_output <- function() {
  convert_test_data_date(
    readr::read_csv(
      test_path("test_data", "format_horizontal_data_table_output.csv"),
      show_col_types = FALSE
    ),
    date
  )
}

format_horizontal_data_key_stats_output <- function() {
  convert_test_data_date(
    readr::read_csv(
      test_path("test_data", "format_horizontal_data_key_stats_output.csv"),
      show_col_types = FALSE
    ),
    date
  )
}

get_horizontal_data_dates_output <- function() {
  convert_test_data_date(
    readr::read_csv(
      test_path("test_data", "get_horizontal_data_dates_output.csv"),
      show_col_types = FALSE
    ),
    date
  )
}

qadip_key_stats_names_series_hierarchy_input <- function() {
  readr::read_csv(
    test_path("test_data", "qadip_key_stats_names_series_hierarchy_input.csv"),
    show_col_types = FALSE
  )
}

qadip_key_stats_names_output <- function() {
  readr::read_csv(
    test_path("test_data", "qadip_key_stats_names_output.csv"),
    show_col_types = FALSE
  )
}

#' Creates data that mimics a .xlsx file
#'
#' @noRd
#'
create_test_xlsx_data <- function() {
  tibble::tibble(
    date = lubridate::rollforward(
      seq.Date(
        as.Date("2015-12-01"),
        as.Date("2016-12-01"),
        by = "1 month"
      )
    ),
    name = "Entity A",
    std_value = 1:13,
    per_value = seq(0.2, 0.8, 0.05)
  )
}

#' Creates a temporary .xlsx file for testing purposes.
#'
#' @noRd
#'
create_test_xlsx_file <- function() {
  temp_file <- tempfile(fileext = ".xlsx")
  wb <- openxlsx::createWorkbook()
  openxlsx::addWorksheet(wb, "Sheet1")
  openxlsx::addWorksheet(wb, "Sheet2")
  openxlsx::writeData(wb, "Sheet1", create_test_xlsx_data())
  openxlsx::addStyle(
    wb = wb,
    sheet = "Sheet1",
    style = openxlsx::createStyle(numFmt = "0%"),
    cols = 4,
    rows = 2:14,
    gridExpand = TRUE
  )
  openxlsx::saveWorkbook(wb, temp_file, overwrite = TRUE)
  return(temp_file)
}

test_that("get_series_hierarchy()", {
  test_input <-
    get_series_hierarchy(
      tidyxl_data = tidyxl_data_input(),
      formatting_data = formatting_data_input(),
      sheet_str_detect = "Tab|^A\\.|Key Stats"
    )

  expect_equal(test_input, get_series_hierarchy_output())
})

test_that("iterate_series_hierarchy()", {
  test_data <- iterate_series_hierarchy_input()

  expect_equal(
    iterate_series_hierarchy(test_data)$series_hierarchy,
    test_data$expected_output
  )

  expect_equal(
    iterate_series_hierarchy(test_data)$sheet_details,
    rep("Dummy Sheet Details", 34)
  )
})

test_that("adjust_indent()", {
  test_data <- iterate_series_hierarchy_input()

  expected_output <-
    dplyr::mutate(
      .data = test_data,
      adjusted_indent =
        c(
          0L, 0L, 1L, 1L, 1L, 1L, 1L, 1L, 0L, 1L,
          0L, 1L, 1L, 0L, 1L, 0L, 1L, 0L, 1L,
          2L, 2L, 3L, 3L, 3L, 2L, 0L, 1L, 2L,
          2L, 3L, 4L, 4L, 2L, 1L
        )
    )

  expect_equal(
    adjust_indent(test_data),
    expected_output
  )
})

test_that("read_tidyxl_data() works as expected", {
  with_tempdir({
    temp_xlsx_file <- create_test_xlsx_file()

    expect_error(
      read_tidyxl_data(temp_xlsx_file, "Sheet"),
      class = "readapra_error_multiple_sheets_selected"
    )
  })
})

test_that("qadip_key_stats_names() behaves as expected", {
  input_data <-
    qadip_key_stats_names(
      qadip_key_stats_names_series_hierarchy_input(),
      tidyxl_data_input()
    )

  expect_equal(input_data, qadip_key_stats_names_output())
})

test_that("format_horizontal_data() behaves as expected", {
  tidyxl_data_input <- tidyxl_data_input()
  formatting_data_input <- formatting_data_input()

  # Testing table data
  output_table <-
    format_horizontal_data(
      tidyxl_data = tidyxl_data_input,
      formatting_data = formatting_data_input,
      stat_pub_name = "Test Pub",
      sheet_str_detect = "Tab",
      frequency = "Test Quarter"
    )

  expect_equal(output_table, format_horizontal_data_table_output())

  # Testing key stats data
  output_key_stats <-
    format_horizontal_data(
      tidyxl_data = tidyxl_data_input,
      formatting_data = formatting_data_input,
      stat_pub_name = "Test Pub",
      sheet_str_detect = "Key",
      frequency = "Test Quarter",
      series_hierarchy_fn = qadip_key_stats_names,
      series_hierarchy_args = list(tidyxl_data = tidyxl_data_input)
    )

  expect_equal(output_key_stats, format_horizontal_data_key_stats_output())
})

test_that("get_horizontal_data_dates() behaves as expected", {
  expect_equal(
    get_horizontal_data_dates(tidyxl_data_input(), "Tab"),
    get_horizontal_data_dates_output()
  )
})

test_that("attempt_format_horizontal_data() behaves as expected", {
  tidyxl_data_input <- tidyxl_data_input()
  formatting_data_input <- formatting_data_input()

  # Testing table data
  output_table <-
    attempt_format_horizontal_data(
      tidyxl_data = tidyxl_data_input,
      formatting_data = formatting_data_input,
      stat_pub_name = "Test Pub",
      sheet_str_detect = "Tab",
      frequency = "Test Quarter",
    )

  expect_equal(output_table, format_horizontal_data_table_output())

  # Testing key stats data
  output_key_stats <-
    attempt_format_horizontal_data(
      tidyxl_data = tidyxl_data_input,
      formatting_data = formatting_data_input,
      stat_pub_name = "Test Pub",
      sheet_str_detect = "Key",
      frequency = "Test Quarter",
      series_hierarchy_fn = qadip_key_stats_names,
      series_hierarchy_args = list(tidyxl_data = tidyxl_data_input)
    )

  expect_equal(output_key_stats, format_horizontal_data_key_stats_output())

  # Mocking for error/warning tests
  local_mocked_bindings(safe_format_horizontal_data = function(...) {
    list(result = NULL, error = "test_error")
  })

  # Testing error
  expect_error(
    attempt_format_horizontal_data(
      tidyxl_data = tidyxl_data_input,
      formatting_data = formatting_data_input,
      stat_pub_name = "Test Pub",
      sheet_str_detect = "Tab",
      frequency = "Test Quarter",
      error_or_warning = "error",
      message = "A test error message"
    ),
    regexp = "A test error message",
    class = "readapra_error_horizontal_data_unreadable"
  )

  # Testing warning
  expect_warning(
    attempt_format_horizontal_data(
      tidyxl_data = tidyxl_data_input,
      formatting_data = formatting_data_input,
      stat_pub_name = "Test Pub",
      sheet_str_detect = "Key",
      frequency = "Test Quarter",
      error_or_warning = "warning",
      message = "A test warning message"
    ),
    regexp = "A test warning message",
    class = "readapra_warning_horizontal_data_unreadable"
  )
})

test_that("format_vertical_data() behaves as expected", {
  # Standard case
  expect_equal(
    format_vertical_data(
      tidyxl_data = vertical_data_input(),
      formatting_data = vertical_formatting_input(),
      stat_pub_name = "Test",
      frequency = "Test frequency"
    ),
    vertical_data_output()
  )

  # Case with col
  expect_equal(
    format_vertical_data(
      tidyxl_data = vertical_data_input(),
      formatting_data = vertical_formatting_input(),
      drop_col = FALSE,
      stat_pub_name = "Test",
      frequency = "Test frequency"
    ),
    dplyr::mutate(.data = vertical_data_output(), col = rep(4:8, 6))
  )
})

test_that("get_col_names() behaves as expected", {
  expect_equal(
    get_col_names(vertical_data_input(), 1:8)$character,
    c("Period", "ABN", "Entity", "Field 1", "Field 2", "Field 3", "Field 4", "Field 5")
  )

  expect_error(
    get_col_names(vertical_data_input(), 0),
    regexp = "Could not extract row names from the xlsx file.",
    class = "readapra_error_could_not_get_row_names"
  )
})

test_that("restructure_as_in_xlsx() behaves as expected", {
  expect_equal(
    restructure_as_in_xlsx(
      existing_cols = existing_cols_input(),
      row_names = row_names_input(),
      data_below_top_row = data_below_top_row_input()
    ),
    restructure_as_in_xlsx_output()
  )
})

test_that("clean_col_names() behaves as expected", {
  expect_equal(
    clean_col_names(pivoted_data = clean_col_names_input()),
    clean_col_names_output()
  )
})

test_that("extra_meta_data() behaves as expected", {
  expect_equal(
    get_extra_meta_data(
      stat_pub_name = "Test name",
      frequency = "Test frequency",
      row_names = row_names_input(),
      existing_cols = existing_cols_input(),
      data_below_top_row = data_below_top_row_input(),
      formatting_data = vertical_formatting_input()
    ),
    get_extra_meta_data_output()
  )
})

test_that("attempt_format_vertical_data() behaves as expected", {
  # Standard case
  expect_equal(
    attempt_format_vertical_data(
      tidyxl_data = vertical_data_input(),
      formatting_data = vertical_formatting_input(),
      stat_pub_name = "Test",
      frequency = "Test frequency"
    ),
    vertical_data_output()
  )

  # Case with col
  expect_equal(
    attempt_format_vertical_data(
      tidyxl_data = vertical_data_input(),
      formatting_data = vertical_formatting_input(),
      drop_col = FALSE,
      stat_pub_name = "Test",
      frequency = "Test frequency"
    ),
    dplyr::mutate(.data = vertical_data_output(), col = rep(4:8, 6))
  )

  # Error in safe_format_vertical_data
  local_mocked_bindings(
    safe_format_vertical_data = function(...) {
      list(result = NULL, error = "Error")
    }
  )

  expect_error(
    attempt_format_vertical_data(
      tidyxl_data = vertical_data_input(),
      formatting_data = vertical_formatting_input(),
      stat_pub_name = "Test",
      frequency = "Test frequency"
    ),
    regexp = "The .xlsx file was in an unrecognised structure and could not be imported.",
    class = "readapra_error_vertical_data_unreadable"
  )
})

#' Check whether a file path is valid and throw an error if not.
#'
#' @param file_path the file path to check
#'
#' @keywords internal
#' @noRd
#'
check_valid_file_path <- function(file_path, call = rlang::caller_env()) {
  check_character_length_one(check_obj = file_path, call = call)

  suppressWarnings(normalised_file_path <- normalizePath(file_path))

  if (!file_exists_wrapper(normalised_file_path)) {
    cli::cli_abort(
      message =
        c(
          c("x" = "No such file exists at: {.path {normalised_file_path}}."),
          c("!" = "Please check you have specified the correct file path.")
        ),
      class = "read_apra_error_file_path_does_not_exist",
      call = call
    )
  }
}

#' Joins together the tidyxl_data and formatting_data
#'
#' @param tidyxl_data The standard data sourced using read_tidyxl_data()
#' @param formatting_data The formatting data sourced using
#' read_tidyxl_formatting_data()
#'
#' @keywords internal
#' @noRd
#'
joined_formatting_data <- function(tidyxl_data, formatting_data) {
  joined_data <-
    dplyr::left_join(
      tidyxl_data,
      tibble::tibble(
        unit = formatting_data$local$numFmt,
        local_format_id = 1:length(formatting_data$local$numFmt)
      ),
      by = dplyr::join_by(local_format_id)
    )

  dplyr::select(.data = joined_data, sheet, row, col, unit)
}

#' Takes a tibble containing a column named "unit" and cleans it
#'
#' @param data Tibble containing a unit column to be cleaned
#'
#' @keywords internal
#' @noRd
#'
clean_unit_data <- function(data) {
  dplyr::mutate(
    .data = data,
    unit = dplyr::case_when(
      stringr::str_detect(unit, "\\%") ~ "Percent",
      stringr::str_detect(series, stringr::regex("Number", ignore_case = TRUE)) ~ "No.",
      .default = "$ million"
    )
  )
}

#' Removes escapes sequences from a vector of characters and any trailing spaces.
#'
#' @param x vector of characters
#'
#' @noRd
#'
remove_escape_sequences <- function(x) {
  superscript_pattern <- "[\u2070\u00B9\u00B2\u00B3\u2074\u2075\u2076\u2077\u2078\u2079\u1D43\u1D47\u1D9C\u1D48\u1D49\u1D4D\u1D4F\u02B0\u2071\u02B2\u1D4A\u02E1\u1D50\u207F\u1D52\u1D56\u1D57\u1D58\u1D5B\u02B3\u02E2\u1D5C\u1D5D\u1D5E\u1D5F\u02B7\u02E3\u02B8\u1DBB]"

  x <- stringr::str_replace_all(x, "[\\r\\n\\t]+", " ")
  x <- stringr::str_replace_all(x, "\\s{2,}", " ")
  x <- stringr::str_replace_all(x, superscript_pattern, "")
  x <- stringr::str_trim(x)
  return(x)
}

#' Check whether an input to an argument is a logical vector of length one.
#' Throws an error if not.
#'
#' @param check_obj the object that is to be checked.
#' @param call_arg the caller argument for the object.
#' @param call the caller environment.
#'
#' @noRd
#'
check_logical_length_one <- function(check_obj,
                                     call_arg = rlang::caller_arg(check_obj),
                                     call = rlang::caller_env()) {
  if (!is.vector(check_obj)) {
    cli::cli_abort(
      message = "{.arg {call_arg}} must be a {.cls logical} vector, not a {.cls {class(check_obj)}} object.",
      class = "readapra_error_input_arg_not_vector",
      call = call
    )
  }

  if (!is.logical(check_obj)) {
    cli::cli_abort(
      message = "{.arg {call_arg}} must be a {.cls logical} vector, not a {.cls {class(check_obj)}} vector.",
      class = "readapra_error_input_arg_not_logical",
      call = call
    )
  }

  if (length(check_obj) != 1) {
    cli::cli_abort(
      message = "{.arg {call_arg}} must be a logical vector of length {.val {1}}, not length {.val {length(check_obj)}}.",
      class = "readapra_error_input_arg_not_length_1",
      call = call
    )
  }
}

#' Check whether an input to an argument is a character vector of length one.
#' Throws an error if not.
#'
#' @param check_obj the object that is to be checked.
#' @param call_arg the caller argument for the object.
#' @param call the caller environment.
#'
#' @noRd
#'
check_character_length_one <- function(check_obj,
                                       call_arg = rlang::caller_arg(check_obj),
                                       call = rlang::caller_env()) {
  if (!is.vector(check_obj)) {
    cli::cli_abort(
      message = "{.arg {call_arg}} must be a {.cls character} vector, not a {.cls {class(check_obj)}} object.",
      class = "readapra_error_input_arg_not_vector",
      call = call
    )
  }

  if (!is.character(check_obj)) {
    cli::cli_abort(
      message = "{.arg {call_arg}} must be a {.cls character} vector, not a {.cls {class(check_obj)}} vector.",
      class = "readapra_error_input_arg_not_character",
      call = call
    )
  }

  if (length(check_obj) != 1) {
    cli::cli_abort(
      message = "{.arg {call_arg}} must be a character vector of length {.val {1}}, not length {.val {length(check_obj)}}.",
      class = "readapra_error_input_arg_not_length_1",
      call = call
    )
  }
}

#' Replaces a set of character columns contents in a data frame
#'
#' @param data the data frame in which character columns need their values replaced
#' @param cols the character columns to replace
#' @param match the matching regex
#' @param replace the replacement for the matching regex
#'
#' @noRd
#'
replace_columns_patterns <- function(data, cols, match, replace) {
  names(replace) <- match

  dplyr::mutate(
    .data = data,
    dplyr::across(
      .cols = {{ cols }},
      .fns = ~ stringr::str_replace_all(.x, pattern = stringr::fixed(replace))
    )
  )
}

#' Convert ABN column to numeric if present
#'
#' @param data a data frame or tibble
#'
#' @noRd
convert_abn <- function(data) {
  if ("abn" %in% names(data)) {
    data <- dplyr::mutate(data, abn = as.numeric(abn))
  }
  data
}

test_that("check_valid_file_path() behaves as expected", {
  # Skip due to divergence across OS systems.
  skip_on_os(c("mac", "linux", "solaris"))

  wrapper_check_valid_file_path <- function(...) {
    check_valid_file_path(...)
  }

  # Invalid file_path
  expect_error(
    wrapper_check_valid_file_path("C:/Users/test_user/test_file.xlsx"),
    class = "read_apra_error_file_path_does_not_exist"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_valid_file_path("C:/Users/test_user/test_file.xlsx")
    },
    error = TRUE
  )

  # Wrong object type
  expect_error(
    wrapper_check_valid_file_path(data.frame()),
    class = "readapra_error_input_arg_not_vector"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_valid_file_path(data.frame())
    },
    error = TRUE
  )

  # Wrong vector type
  expect_error(
    wrapper_check_valid_file_path(1:5),
    class = "readapra_error_input_arg_not_character"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_valid_file_path(1:5)
    },
    error = TRUE
  )

  # Wrong length
  expect_error(
    wrapper_check_valid_file_path(c("test_a", "test_b")),
    class = "readapra_error_input_arg_not_length_1"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_valid_file_path(c("test_a", "test_b"))
    },
    error = TRUE
  )
})

test_that("check_logical_length_one() behaves as expected", {
  wrapper_check_logical_length_one <- function(...) {
    check_logical_length_one(...)
  }

  # Wrong object type
  expect_error(
    wrapper_check_logical_length_one(data.frame()),
    class = "readapra_error_input_arg_not_vector"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_logical_length_one(data.frame())
    },
    error = TRUE
  )

  # Wrong vector type
  expect_error(
    wrapper_check_logical_length_one(1:5),
    class = "readapra_error_input_arg_not_logical"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_logical_length_one(1:5)
    },
    error = TRUE
  )

  # Wrong length
  expect_error(
    wrapper_check_logical_length_one(c(TRUE, FALSE, TRUE)),
    class = "readapra_error_input_arg_not_length_1"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_logical_length_one(c(TRUE, FALSE, TRUE))
    },
    error = TRUE
  )
})

test_that("check_character_length_one() behaves as expected", {
  wrapper_check_character_length_one <- function(...) {
    check_character_length_one(...)
  }

  # Wrong object type
  expect_error(
    wrapper_check_character_length_one(data.frame()),
    class = "readapra_error_input_arg_not_vector"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_character_length_one(data.frame())
    },
    error = TRUE
  )

  # Wrong vector type
  expect_error(
    wrapper_check_character_length_one(1:5),
    class = "readapra_error_input_arg_not_character"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_character_length_one(1:5)
    },
    error = TRUE
  )

  # Wrong length
  expect_error(
    wrapper_check_character_length_one(c("test_a", "test_b")),
    class = "readapra_error_input_arg_not_length_1"
  )

  testthat::expect_snapshot(
    {
      wrapper_check_character_length_one(c("test_a", "test_b"))
    },
    error = TRUE
  )
})

test_that("replace_columns_patterns() behaves as expected", {
  input_data <-
    tibble::tribble(
      ~col1, ~col2,
      "This is (a test) example a", "This is (a test) example a",
      "A dollar ($) sign example", "A dollar ($) sign example",
      "A percentage sign % example", "A percentage sign % example",
      "Some of example z", "Some of example z",
      "An unaltered value", "An unaltered value"
    )

  match_replacement_inputs <-
    tibble::tribble(
      ~match, ~replacement,
      "This is (a test) example a", "This is (a test) example",
      "A dollar ($) sign example", "A dollar sign example",
      "A percentage sign % example", "A percentage sign example",
      "Some of example z", "Some of example"
    )

  expected_output <-
    tibble::tribble(
      ~col1, ~col2,
      "This is (a test) example", "This is (a test) example",
      "A dollar sign example", "A dollar sign example",
      "A percentage sign example", "A percentage sign example",
      "Some of example", "Some of example",
      "An unaltered value", "An unaltered value"
    )

  expect_equal(
    replace_columns_patterns(
      data = input_data,
      cols = c("col1", "col2"),
      match = match_replacement_inputs$match,
      replace = match_replacement_inputs$replacement
    ),
    expected_output
  )
})

#' Read Quarterly ADI Performance Statistics
#'
#' @description
#' Import the Quarterly Authorised Deposit-taking Institution
#' Performance Statistics (QADIPS) from a local file.
#'
#' @param file_path path to the local .xlsx file.
#' @param cur_hist character vector determining whether to download the current
#' publication (`"current"`) or the historic publication (`"historic"`).
#'
#' @return A tibble containing the Quarterly ADI Performance Statistics data.
#'
#' @noRd
#'
read_qadips <- function(file_path, cur_hist, call = rlang::caller_env()) {
  tidyxl_data <- read_tidyxl_data(file_path, call = call)
  formatting_data <- read_tidyxl_formatting_data(file_path)
  qadips_data(tidyxl_data, formatting_data, call = call)
}

#' Combines the various QADIP data tibbles together alongside final formatting
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#' @param call the caller environment
#'
#' @keywords internal
#' @noRd
#'
qadips_data <- function(tidyxl_data,
                        formatting_data,
                        call = rlang::caller_env()) {
  qadips_name <- "Quarterly Authorised Deposit-taking Institution Performance Statistics"
  qadips_frequency <- "Quarterly"

  qadips_tab_data <-
    attempt_format_horizontal_data(
      tidyxl_data = tidyxl_data,
      formatting_data = formatting_data,
      stat_pub_name = qadips_name,
      sheet_str_detect = "Tab",
      frequency = qadips_frequency,
      call = call
    )

  qadips_key_stats_data <-
    attempt_format_horizontal_data(
      tidyxl_data = tidyxl_data,
      formatting_data = formatting_data,
      stat_pub_name = qadips_name,
      sheet_str_detect = "Key",
      frequency = qadips_frequency,
      series_hierarchy_fn = qadip_key_stats_names,
      error_or_warning = "warning",
      message = "Could not extract data from the {.code Key Stats} sheet. Data from the {.code Key Stats} sheet has been omitted.",
      series_hierarchy_args = list(tidyxl_data = tidyxl_data),
      call = call
    )

  qadips_data <- dplyr::bind_rows(qadips_key_stats_data, qadips_tab_data)

  qadips_data <-
    replace_columns_patterns(
      data = qadips_data,
      cols = c("series_hierarchy", "series"),
      match = qadips_string_replacement$match,
      replace = qadips_string_replacement$replacement
    )

  return(qadips_data)
}

#' Malformed strings in the QADIPS that need replacing
#'
#' @noRd
#'
qadips_string_replacement <-
  tibble::tribble(
    ~match, ~replacement,
    "All ADIs a", "All ADIs",
    "Return on assets (after tax) a", "Return on assets (after tax)",
    "Return on equity (after tax) a", "Return on equity (after tax)",
    "Net profit (loss) after taxa", "Net profit (loss) after tax"
  )

test_that("read_qadips() behaves as expected", {
  skip_if_offline()
  skip_on_cran()

  with_tempdir({
    qadips_path <- download_apra("qadips", "current", quiet = TRUE)
    qadips <- read_qadips(qadips_path, "current")
    expect_s3_class(qadips, "tbl_df")
    expect_equal(
      purrr::map(qadips, class),
      list(
        statistics_publication_name = "character",
        date = "Date",
        sheet = "character",
        sheet_details = "character",
        series_hierarchy = "character",
        series = "character",
        frequency = "character",
        unit = "character",
        value = "numeric"
      )
    )
  })
})

#' Read Monthly ADI Statistics
#'
#' @description
#' Import the Monthly Authorised Deposit-taking Institution Statistics (MADIS)
#' from a local file. Both the current and historic versions of this
#' statistical publication are available.
#'
#' @param file_path path to the local .xlsx file.
#' @param cur_hist character vector determining whether to download the current
#' publication (`"current"`) or the historic publication (`"historic"`).
#'
#' @return A tibble containing the Monthly ADI Statistics data.
#'
#' @noRd
#'
read_madis <- function(file_path, cur_hist, call = rlang::caller_env()) {
  tidyxl_data <- read_tidyxl_data(file_path, "table.*1", call = call)
  formatting_data <- read_tidyxl_formatting_data(file_path)
  madis_data(tidyxl_data, formatting_data, cur_hist)
}

#' Extracts the MADIS data and cleans it
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#' @param cur_hist character vector determining whether to download the current
#' publication (`"current"`) or the historic publication (`"historic"`).
#'
#' @noRd
#'
madis_data <- function(tidyxl_data,
                       formatting_data,
                       cur_hist,
                       call = rlang::caller_env()) {
  madis_data <-
    attempt_format_vertical_data(
      tidyxl_data = tidyxl_data,
      formatting_data = formatting_data,
      stat_pub_name = "Monthly Authorised Deposit-taking Institution Statistics",
      frequency = "Monthly",
      drop_col = FALSE,
      call = call
    )
  madis_data <- add_madis_balance_sheet(madis_data, cur_hist, call)
  madis_data <- dplyr::select(.data = madis_data, !col)
  madis_data <- convert_abn(madis_data)
  madis_data <-
    dplyr::arrange(
      .data = madis_data,
      date,
      institution_name,
      balance_sheet_category,
      series
    )

  return(madis_data)
}

#' Adds a balance sheet category to the MADIS data. Certain MADIS series have
#' the same name, adding this column helps distinguish them.
#'
#' @param madis_data the cleaned MADIS data
#' @param cur_hist character vector determining whether to download the current
#' publication (`"current"`) or the historic publication (`"historic"`).
#'
#' @keywords internal
#' @noRd
#'
add_madis_balance_sheet <- function(madis_data,
                                    cur_hist,
                                    call = rlang::caller_env()) {
  original_col <- madis_data$col
  madis_data$col <- madis_data$col - min(madis_data$col) + 1

  if (cur_hist == "current") {
    madis_data <-
      dplyr::left_join(
        x = madis_data,
        y = madis_current_balance_sheet,
        by = dplyr::join_by("series", "col")
      )
  }

  if (cur_hist == "historic") {
    madis_data <-
      dplyr::left_join(
        x = madis_data,
        y = madis_historic_balance_sheet,
        by = dplyr::join_by("series", "col")
      )
  }

  if (any(is.na(madis_data$balance_sheet_category))) {
    cli::cli_warn(
      message = "Could not successfully attach contents of {.code balance_sheet_category} column. The contents of this column are incomplete.",
      class = "readapra_warning_nas_in_madis_balance_sheet_category"
    )
  }

  madis_data <- dplyr::relocate(
    .data = madis_data, balance_sheet_category, .before = series
  )

  madis_data$col <- original_col

  return(madis_data)
}

test_that("read_madis() real download", {
  skip_if_offline()
  skip_on_cran()

  with_tempdir({
    current_madis_path <- download_apra("madis", "current", quiet = TRUE)
    current_madis <- read_madis(current_madis_path, "current")
    historic_madis_path <- download_apra("madis", "historic", quiet = TRUE)
    historic_madis <- read_madis(historic_madis_path, "historic")
  })

  # Testing current MADIS
  expect_s3_class(current_madis, "tbl_df")
  expect_equal(
    purrr::map(current_madis, class),
    list(
      statistics_publication_name = "character",
      date = "Date",
      abn = "numeric",
      institution_name = "character",
      balance_sheet_category = "character",
      series = "character",
      frequency = "character",
      unit = "character",
      value = "numeric"
    )
  )

  # Testing historic MADIS
  expect_s3_class(historic_madis, "tbl_df")
  expect_equal(
    purrr::map(historic_madis, class),
    list(
      statistics_publication_name = "character",
      date = "Date",
      abn = "numeric",
      institution_name = "character",
      balance_sheet_category = "character",
      series = "character",
      frequency = "character",
      unit = "character",
      value = "numeric"
    )
  )
})

test_that("add_madis_balance_sheet() behaves as expected", {
  # MADIS current testing ---------------------------------------------------
  set.seed(123)
  madis_current_input_data <-
    tibble::tibble(
      date = as.Date("2024-12-31"),
      abn = 1111111,
      entity = "Entity A",
      series = madis_current_balance_sheet$series,
      value = rnorm(27),
      col = 201:227
    )

  madis_current_output_data <-
    dplyr::mutate(
      .data = madis_current_input_data,
      balance_sheet_category = madis_current_balance_sheet$balance_sheet_category,
      .before = series
    )

  # Standard test
  expect_equal(
    add_madis_balance_sheet(madis_current_input_data, "current"),
    madis_current_output_data
  )

  # Warning test
  madis_current_input_data$series <-
    dplyr::if_else(
      condition = madis_current_input_data$series == "Trading securities",
      true = "Trade Securities",
      false = madis_current_input_data$series
    )

  expect_warning(
    add_madis_balance_sheet(madis_current_input_data, "current"),
    class = "readapra_warning_nas_in_madis_balance_sheet_category"
  )

  # MADIS historic testing --------------------------------------------------
  set.seed(123)
  madis_historic_input_data <-
    tibble::tibble(
      date = as.Date("2024-12-31"),
      abn = 1111111,
      entity = "Entity A",
      series = madis_historic_balance_sheet$series,
      value = rnorm(35),
      col = 201:235
    )

  madis_historic_output_data <-
    dplyr::mutate(
      .data = madis_historic_input_data,
      balance_sheet_category = madis_historic_balance_sheet$balance_sheet_category,
      .before = series
    )

  # Standard test
  expect_equal(
    add_madis_balance_sheet(madis_historic_input_data, "historic"),
    madis_historic_output_data
  )

  # Warning test
  madis_historic_input_data$series <-
    dplyr::if_else(
      condition = madis_historic_input_data$series == "Trading securities",
      true = "Trade Securities",
      false = madis_historic_input_data$series
    )

  expect_warning(
    add_madis_balance_sheet(madis_historic_input_data, "historic"),
    class = "readapra_warning_nas_in_madis_balance_sheet_category"
  )
})

#' Extracts vertical sheet data using the supplied tidyxl_data and formatting_data
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#' @param stat_pub_name the name of the statistical publication
#' @param drop_col whether or not to drop the column identifier column for each
#' series
#'
#' @noRd
#'
format_vertical_data <- function(tidyxl_data,
                                 formatting_data,
                                 stat_pub_name,
                                 frequency,
                                 drop_col = TRUE) {
  existing_cols <- sort(unique(tidyxl_data$col))

  row_names <- get_col_names(tidyxl_data, existing_cols)

  data_below_top_row <-
    dplyr::filter(.data = tidyxl_data, row > unique(row_names$row))

  restructured_data <-
    restructure_as_in_xlsx(existing_cols, row_names, data_below_top_row)

  pivoted_data <-
    tidyr::pivot_longer(
      data = restructured_data,
      cols = !tidyselect::contains("abn", ignore.case = TRUE) &
        dplyr::where(is.numeric),
      names_to = "series",
      values_to = "value"
    )

  name_cleaned_data <- clean_col_names(pivoted_data)

  extra_meta_data <-
    get_extra_meta_data(
      frequency = frequency,
      stat_pub_name = stat_pub_name,
      row_names, existing_cols, data_below_top_row, formatting_data
    )

  cleaned_data <-
    dplyr::left_join(
      x = name_cleaned_data,
      y = extra_meta_data,
      by = dplyr::join_by("col", "series"),
      relationship = "many-to-one"
    )

  cleaned_data <- dplyr::relocate(
    .data = cleaned_data, unit, .before = value
  )

  cleaned_data <- dplyr::relocate(
    .data = cleaned_data, statistics_publication_name, .before = 1
  )

  cleaned_data <- dplyr::relocate(
    .data = cleaned_data, frequency, .before = unit
  )

  if (drop_col) {
    cleaned_data <- dplyr::select(cleaned_data, !col)
  }

  return(cleaned_data)
}

#' Takes the tidyxl data and returns the data about the top row of names
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param existing_cols the number of valid columns in the .xlsx file
#'
#' @noRd
#'
get_col_names <- function(tidyxl_data, existing_cols) {
  row_names <-
    dplyr::filter(
      .data = tidyxl_data,
      all(data_type == "character"), setequal(existing_cols, col),
      .by = "row"
    )

  if (length(row_names$character) < 1) {
    cli::cli_abort(
      message = "Could not extract row names from the xlsx file.",
      class = "readapra_error_could_not_get_row_names"
    )
  }

  return(row_names)
}

#' Restructures the tidy_xl data so that it resembles what was originally in
#' the .xlsx file
#'
#' @param existing_cols the number of valid columns in the .xlsx file
#' @param row_names the tibble containing the row names data
#' @param data_below_top_row the tibble containing the data below the row names
#'
#' @noRd
#'
restructure_as_in_xlsx <- function(existing_cols,
                                   row_names,
                                   data_below_top_row) {
  list_column_data <-
    purrr::map(
      .x = existing_cols,
      .f = ~ get_column_data(.x, data = data_below_top_row)
    )
  rejoined_column_data <-
    purrr::reduce(
      .x = list_column_data,
      .f = dplyr::left_join,
      by = dplyr::join_by("row")
    )

  renamed_column_data <-
    rlang::set_names(
      x = dplyr::select(.data = rejoined_column_data, !row),
      nm = paste0(row_names$character, "_", existing_cols)
    )
  return(renamed_column_data)
}

#' Takes a tibble containing column data and extracts each column irrespective
#' of its data type
#'
#' @param col_num the column number in the sheet to extract
#' @param data the data to extract column number data from
#'
#' @noRd
#'
get_column_data <- function(col_num, data) {
  col_data <- dplyr::filter(.data = data, col == col_num)
  col_data <- dplyr::mutate(.data = col_data, date = lubridate::as_date(date))
  col_data <- dplyr::select(.data = col_data, row, error, logical, numeric, date, character)
  col_data <- dplyr::select(.data = col_data, dplyr::where(~ !all(is.na(.))))
}

#' Takes the pivoted data and cleans the column names and extracts the col column
#'
#' @param pivoted_data the pivoted data to be cleaned
#'
#' @noRd
#'
clean_col_names <- function(pivoted_data) {
  cleaned_names_data <- janitor::clean_names(pivoted_data)

  names(cleaned_names_data) <-
    stringr::str_remove_all(names(cleaned_names_data), "_\\d+$")

  cleaned_names_data$series <- remove_escape_sequences(cleaned_names_data$series)

  cleaned_names_data <-
    tidyr::separate_wider_regex(
      data = cleaned_names_data,
      cols = series,
      patterns = c(series = ".*", "_", col = ".*")
    )

  # Second run to align with meta data
  cleaned_names_data$series <- remove_escape_sequences(cleaned_names_data$series)

  cleaned_names_data <-
    dplyr::relocate(cleaned_names_data, col, .after = tidyselect::last_col())

  cleaned_names_data$col <- as.numeric(cleaned_names_data$col)

  names(cleaned_names_data) <-
    dplyr::case_when(
      stringr::str_detect(
        string = "^period$",
        pattern = stringr::str_trim(
          stringr::regex(names(cleaned_names_data), ignore_case = TRUE)
        )
      ) ~ "date",
      .default = names(cleaned_names_data)
    )

  return(cleaned_names_data)
}

#' Generates additional meta data to attach to the output tibble using the
#' formatting data (i.e unit and column number)
#'
#' @param stat_pub_name the name of the statistical publication
#' @param row_names the tibble containing the row names data
#' @param existing_cols the existing cols
#' @param data_below_top_row the tibble containing the data below the row names
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#'
#' @noRd
#'
get_extra_meta_data <- function(stat_pub_name,
                                frequency,
                                row_names,
                                existing_cols,
                                data_below_top_row,
                                formatting_data) {
  column_binder <-
    dplyr::mutate(
      .data = tibble::tibble(series = row_names$character),
      col = existing_cols
    )

  extra_meta_data <- joined_formatting_data(data_below_top_row, formatting_data)

  # Sometimes formatting changes across column. Taking most frequent formatting.
  extra_meta_data <-
    dplyr::summarise(
      .data = extra_meta_data,
      count = dplyr::n(),
      .by = c(col, unit)
    )
  extra_meta_data <- dplyr::slice_max(.data = extra_meta_data, count, by = col)
  extra_meta_data <- dplyr::select(.data = extra_meta_data, col, unit)

  # Joining data together
  extra_meta_data <- dplyr::left_join(column_binder, extra_meta_data, by = "col")
  extra_meta_data <- clean_unit_data(extra_meta_data)
  extra_meta_data$series <- remove_escape_sequences(extra_meta_data$series)
  extra_meta_data$statistics_publication_name <- stat_pub_name
  extra_meta_data$frequency <- frequency

  return(extra_meta_data)
}

#' Safely get the vertical sheet data
#'
#' @noRd
#'
safe_format_vertical_data <- purrr::safely(format_vertical_data)

#' Attempts to get the QADIPS Key Stats sheet data and if it encounters an error
#' it throws a warning and returns a empty tibble
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#' @param stat_pub_name the name of the statistical publication
#' @param col whether or not to drop the column identifier column for each
#' series
#' @param call the caller environment
#'
#' @keywords internal
#' @noRd
#'
attempt_format_vertical_data <-
  function(tidyxl_data,
           formatting_data,
           stat_pub_name,
           frequency,
           drop_col = TRUE,
           call = rlang::caller_env()) {
    outcome <- safe_format_vertical_data(
      tidyxl_data, formatting_data, stat_pub_name, frequency,
      drop_col = drop_col
    )
    if (!is.null(outcome$error)) {
      cli::cli_abort(
        message = "The .xlsx file was in an unrecognised structure and could not be imported.",
        class = "readapra_error_vertical_data_unreadable",
        call = call
      )
    } else {
      return(outcome$result)
    }
  }

#' Statistical Publications Produced by APRA
#'
#' This dataset contains a record of all statistical publications produced by
#' APRA that are available in `readapra`.
#'
#' @format A data frame with 7 rows and 3 variables:
#' \describe{
#'  \item{stat_pub_name}{the full name of the statistical publication.}
#'  \item{stat_pub_acronym}{the acronym of the statistical publication.}
#'  \item{cur_hist}{available current and historical versions of the statistical publication.}
#' }
#'
"apra_stat_pubs"

#' Download a Statistical Publication File from APRA's Website
#'
#' @description
#' Download a statistical publication file from APRA's website. By
#' default files are saved to a temporary directory.
#'
#' @param stat_pub character vector detailing a statistical publication to be
#' downloaded. Must match a valid value in the
#' `apra_stat_pubs_acronym` variable of the [apra_stat_pubs] dataset.
#' @param cur_hist character vector detailing whether to download a current
#' or historic statistical publication. Must match a
#' valid value in the `cur_hist` variable of the [apra_stat_pubs]
#' dataset.
#' @param path path to where the downloaded file should be saved. Uses
#' [base::tempdir()] by default.
#' @param overwrite whether to overwrite a previously downloaded statistical
#' publication file when re-running this function.
#' @param quiet whether to suppress the download progress bar.
#' @param ... additional arguments to be passed to [utils::download.file()].
#'
#' @return A character vector detailing the file path to the downloaded file.
#'
#' @export
#'
#' @examples
#' \donttest{
#' # Download a statistical publication file:
#' download_path <-
#'   download_apra(stat_pub = "qadips", cur_hist = "current")
#'
#' # View the file path of the statistical publication file:
#' print(download_path)
#' }
#'
download_apra <- function(
    stat_pub,
    cur_hist = "current",
    path = tempdir(),
    overwrite = TRUE,
    quiet = FALSE,
    ...) {
  download_apra_with_caller(
    stat_pub = stat_pub,
    cur_hist = cur_hist,
    path = path,
    overwrite = overwrite,
    quiet = quiet,
    ...
  )
}

#' Download a Publication Statistics File from APRA's Website with caller
#' environment control
#'
#' @param stat_pub character vector containing the acronym of the publication
#' statistics you want to download.
#' @param cur_hist character vector determining whether to download the current
#' publication (`"current"`) or the historic publication (`"historic"`). Please
#' note that not all statistical publications have a historic publication.
#' @param path path to where the downloaded file should be saved. Uses
#' [base::tempdir()] by default.
#' @param overwrite whether to overwrite the downloaded file when re-downloading
#' the file.
#' @param quiet whether to suppress the download progress bar.
#' @param call Caller environment for error handling
#' @param ... additional arguments to be passed to [utils::download.file()].
#'
#' @noRd
#'
download_apra_with_caller <- function(stat_pub,
                                      cur_hist,
                                      path = tempdir(),
                                      overwrite = TRUE,
                                      quiet = FALSE,
                                      call = rlang::caller_env(),
                                      ...) {
  check_valid_file_path(path, call)
  check_standard_user_inputs(stat_pub, cur_hist, call = call)
  check_logical_length_one(overwrite, call = call)
  check_logical_length_one(quiet, call = call)

  selected_stat_pub <-
    dplyr::filter(
      apra_stat_pubs_details,
      stat_pub_acronym == stat_pub,
      cur_hist == {{ cur_hist }}
    )

  check_http_status(
    url = selected_stat_pub$webpage_link,
    error_message = "Could not scrape url to download from:",
    call = call
  )

  extracted_urls <- scrape_urls(selected_stat_pub$webpage_link)
  url_to_download <- url_selector(extracted_urls, selected_stat_pub)

  download_location <-
    attempt_file_download(
      url = url_to_download,
      path = path,
      overwrite = overwrite,
      quiet = quiet,
      call = call
    )

  return(download_location)
}

#' Scrape URLs from a webpage
#'
#' @param url The URL of the webpage to extract links from
#'
#' @noRd
#'
scrape_urls <- function(url) {
  resp <- httr::GET(
    url,
    httr::user_agent("readapra R package")
  )

  if (httr::http_error(resp)) {
    cli::cli_abort(
      c(
        "Could not scrape URL: {.url {url}}",
        "x" = httr::http_status(resp)$message
      )
    )
  }

  page <- httr::content(resp, as = "parsed")

  urls <-
    rvest::html_attr(
      x = rvest::html_elements(page, "a"),
      "href"
    )

  urls <- urls[
    !is.na(urls) &
      nzchar(urls) &
      !grepl("^#", urls) &
      !grepl("^javascript:", urls)
  ]

  urls <- xml2::url_absolute(urls, base = url)

  return(urls)
}

#' Get the download method from the R_READAPRA_DL_METHOD environment variable
#'
#' @noRd
#'
get_dl_method <- function() {
  Sys.getenv("R_READAPRA_DL_METHOD", unset = "auto")
}

#' Use the httr package to get status information about a URL
#'
#' @param url The URL link to get status information about
#'
#' @noRd
#'
get_http_status <- function(url) {
  httr::http_status(httr::GET(url))
}

#' Check the http status of a URL and throw an error if unable to get a success
#'
#' @param url The URL link to be checked
#' @param call The caller environment
#'
#' @noRd
#'
check_http_status <- function(url,
                              error_message = "Could not access:",
                              call = rlang::caller_env()) {
  url_status <- get_http_status(url)
  if (url_status$category != "Success") {
    cli::cli_abort(
      message = c(
        "{error_message} {.url {url}}",
        c("x" = url_status$message)
      ),
      class = "readapra_error_http_status_error",
      call = call
    )
  }

  return()
}

#' Download a file using utils::download.file
#'
#' @param url the URL of the file to be downloaded
#' @param path path where to save the destfile.
#' @param overwrite if `TRUE` will overwrite file on disk
#' @param quiet If `TRUE`, suppress the download progress bar.
#' @param ... Other parameters passed on to [utils::download.file()]
#'
#' @noRd
#'
file_download <- function(url,
                          path = tempdir(),
                          overwrite = TRUE,
                          quiet = FALSE,
                          ...) {
  destfile <- file.path(path, basename(url))

  if (file.exists(destfile) && !overwrite) {
    return(destfile)
  }

  utils::download.file(
    url = url,
    destfile = destfile,
    method = get_dl_method(),
    quiet = quiet,
    mode = "wb",
    ...
  )

  return(destfile)
}

#' Safely download a file
#'
#' @noRd
#'
safe_file_download <- purrr::safely(file_download)

#' Attempt to download a file, retrying once on failure
#'
#' @param url the URL of the file to be downloaded
#' @param path path where to save the destfile.
#' @param overwrite if `TRUE` will overwrite file on disk
#' @param quiet If `TRUE`, suppress the download progress bar.
#' @param call The caller environment
#' @param ... Other parameters passed on to [utils::download.file()]
#'
#' @noRd
#'
attempt_file_download <- function(url,
                                  path = tempdir(),
                                  overwrite = TRUE,
                                  quiet = FALSE,
                                  call = rlang::caller_env(),
                                  ...) {
  download_outcome <-
    safe_file_download(
      url = url,
      path = path,
      overwrite = overwrite,
      quiet = quiet,
      ...
    )

  if (!is.null(download_outcome$error)) {
    sys_sleep_wrapper(5)
    download_outcome <-
      safe_file_download(
        url = url,
        path = path,
        overwrite = overwrite,
        quiet = quiet,
        ...
      )
  }

  if (!is.null(download_outcome$error)) {
    cli::cli_abort(
      message = c(
        "Could not download file from: {.url {url}}",
        get_http_status(url)$message
      ),
      class = "readapra_error_could_not_download_file",
      call = call
    )
  }

  return(download_outcome$result)
}

test_that("download_apra() real file download", {
  skip_if_offline()
  skip_on_cran()

  with_tempdir({
    # Test correct QADIPS download
    expect_true(
      file.exists(
        download_apra(
          stat_pub = "qadips",
          cur_hist = "current",
          quiet = TRUE
        )
      )
    )

    # Test correct MADIS download
    expect_true(
      file.exists(
        download_apra(
          stat_pub = "madis",
          cur_hist = "historic",
          quiet = TRUE
        )
      )
    )
  })
})

test_that("download_apra() download error handling", {
  # Error if can't get connection
  local_mocked_bindings(
    get_http_status = function(...) {
      list(
        category = "Client error",
        reason = "Not Found",
        message = "Client error: (404) Not Found"
      )
    }
  )

  expect_error(
    download_apra(stat_pub = "qadips", cur_hist = "current"),
    regexp = "Could not scrape url to download from:",
    class = "readapra_error_http_status_error"
  )

  # Error if can't download
  local_mocked_bindings(
    get_http_status = function(...) {
      list(
        category = "Success",
        reason = "OK",
        message = "Success: (200) OK"
      )
    }
  )
  local_mocked_bindings(scrape_urls = function(...) NULL)
  local_mocked_bindings(url_selector = function(...) NULL)
  local_mocked_bindings(sys_sleep_wrapper = function(...) NULL)
  local_mocked_bindings(safe_file_download = function(...) {
    list(result = NULL, error = "Error")
  })

  expect_error(
    download_apra(stat_pub = "qadips", cur_hist = "current"),
    regexp = "Could not download file from:",
    class = "readapra_error_could_not_download_file"
  )
})

test_that("scrape_urls() behaves as expected", {
  enable(quiet = TRUE)

  mock_html <-
    "
<html>
  <body>
    <a href='https://example.com/link1'>Link 1</a>
    <a href='https://example.com/link2'>Link 2</a>
  </body>
</html>
"

  to_return(
    .data = stub_request("get", "https://example.com"),
    body = mock_html,
    status = 200,
    headers = list("Content-Type" = "text/html; charset=utf-8")
  )

  urls <- scrape_urls("https://example.com")

  expect_equal(urls, c("https://example.com/link1", "https://example.com/link2"))

  disable(quiet = TRUE)
})

test_that("check_http_status() behaves as expected", {
  enable(quiet = TRUE)

  to_return(.data = stub_request("get", "https://example.com/success"), status = 200)
  to_return(.data = stub_request("get", "https://example.com/notfound"), status = 404)
  to_return(.data = stub_request("get", "https://example.com/servererror"), status = 501)

  expect_no_error(check_http_status("https://example.com/success"))

  expect_error(
    check_http_status(
      url = "https://example.com/notfound",
      error_message = "Encountered error:"
    ),
    regexp = "Encountered error: ",
    class = "readapra_error_http_status_error"
  )

  expect_error(
    check_http_status(
      url = "https://example.com/servererror",
      error_message = "Encountered error:"
    ),
    regexp = "Encountered error: ",
    class = "readapra_error_http_status_error"
  )

  disable(quiet = TRUE)
})

test_that("get_http_status() returns http details", {
  enable(quiet = TRUE)

  to_return(.data = stub_request("get", "https://example.com/success"), status = 200)
  to_return(.data = stub_request("get", "https://example.com/notfound"), status = 404)
  to_return(.data = stub_request("get", "https://example.com/servererror"), status = 501)

  expect_equal(
    get_http_status("https://example.com/success"),
    list(
      category = "Success",
      reason = "OK",
      message = "Success: (200) OK"
    )
  )

  expect_equal(
    get_http_status("https://example.com/notfound"),
    list(
      category = "Client error",
      reason = "Not Found",
      message = "Client error: (404) Not Found"
    )
  )

  expect_equal(
    get_http_status("https://example.com/servererror"),
    list(
      category = "Server error",
      reason = "Not Implemented",
      message = "Server error: (501) Not Implemented"
    )
  )

  disable(quiet = TRUE)
})

test_that("file_download() real file download", {
  skip_if_offline()
  skip_on_cran()

  with_tempdir({
    expect_true(
      file.exists(
        file_download(
          url = "https://httpbin.org/bytes/512",
          quiet = TRUE
        )
      )
    )
  })
})

test_that("attempt_file_download() error behaviour", {
  # Checking safe fall backs
  local_mocked_bindings(sys_sleep_wrapper = function(...) NULL)
  local_mocked_bindings(safe_file_download = function(...) list(result = NULL, error = "Error"))
  local_mocked_bindings(get_http_status = function(...) list(message = "get_http_status_message"))

  expect_error(
    attempt_file_download(url = "dummy_url"),
    class = "readapra_error_could_not_download_file"
  )
})

test_that("attempt_file_download() real file download", {
  skip_if_offline()
  skip_on_cran()

  with_tempdir({
    expect_true(
      file.exists(
        attempt_file_download(
          url = "https://httpbin.org/bytes/512",
          quiet = TRUE
        )
      )
    )
  })
})

test_that("read_qadipexs() behaves as expected", {
  skip_if_offline()
  skip_on_cran()

  with_tempdir({
    current_qadipexs_path <- download_apra("qadipexs", "current", quiet = TRUE)
    current_qadipexs <- read_qadipexs(current_qadipexs_path, "current")
    historic_qadipexs_path <- download_apra("qadipexs", "current", quiet = TRUE)
    historic_qadipexs <- read_qadipexs(current_qadipexs_path, "historic")
  })

  # Testing current QADIPEXS
  expect_s3_class(current_qadipexs, "tbl_df")
  expect_equal(
    purrr::map(current_qadipexs, class),
    list(
      statistics_publication_name = "character",
      date = "Date",
      sheet = "character",
      sheet_details = "character",
      series_hierarchy = "character",
      series = "character",
      frequency = "character",
      unit = "character",
      value = "numeric"
    )
  )

  # Testing historic QADIPEXS
  expect_s3_class(historic_qadipexs, "tbl_df")
  expect_equal(
    purrr::map(historic_qadipexs, class),
    list(
      statistics_publication_name = "character",
      date = "Date",
      sheet = "character",
      sheet_details = "character",
      series_hierarchy = "character",
      series = "character",
      frequency = "character",
      unit = "character",
      value = "numeric"
    )
  )
})

#' Gets dependency names for the Key Stats sheet in the QADIP. This sheet is
#' structured differently from the other sheets and needs a lot of tweaking to
#' get working.
#'
#' @param tidyxl_data The QADIP data sourced using the tidyxl package
#' @param series_hierarchy_data The series dependency data sourced using
#' get_series_dependencies()
#'
#' @keywords internal
#' @noRd
#'
qadip_key_stats_names <- function(series_hierarchy_data, tidyxl_data) {
  cohort_rows <-
    dplyr::filter(.data = series_hierarchy_data, series_hierarchy == "ADIs")$row

  key_figures_row <-
    dplyr::filter(.data = tidyxl_data, character %in% c("Key figures"))$row

  if (length(cohort_rows) != 2 | length(key_figures_row) != 1) {
    cli::cli_abort(
      message = "Structure of the 'Key Stats' sheet has changed. Unable to extract data.",
      class = "readapra_error_key_figures_or_cohort_rows_wrong"
    )
  }

  cleaned_key_stats_names <-
    dplyr::mutate(
      .data = series_hierarchy_data,
      group_id = dplyr::row_number(),
      .by = series_hierarchy
    )

  cleaned_key_stats_names <-
    dplyr::mutate(
      .data = cleaned_key_stats_names,
      measure_type =
        dplyr::case_when(
          row >= key_figures_row ~ "summary_stat",
          row < key_figures_row & row >= max(cohort_rows) ~ "Number of entities",
          row > min(cohort_rows) & row <= max(cohort_rows) ~ "Assets"
        )
    )

  cleaned_key_stats_names <-
    dplyr::mutate(
      .data = cleaned_key_stats_names,
      series =
        dplyr::case_when(
          group_id == 1 & measure_type == "summary_stat" ~
            "ADIs (excludes 'other ADIs')",
          group_id == 2 & measure_type == "summary_stat" ~
            "Banks",
          group_id == 3 & measure_type == "summary_stat" ~
            "Credit unions and building societies",
          .default = measure_type
        ),
      series_hierarchy = stringr::str_c(series, "; ", series_hierarchy)
    )

  max_number_summary_stat_groups <-
    max(dplyr::filter(cleaned_key_stats_names, measure_type == "summary_stat")$group_id)

  if (max_number_summary_stat_groups != 3) {
    cli::cli_abort(
      message = "Structure of the 'Key Stats' sheet has changed. Unable to extract data.",
      class = "readapra_error_wrong_number_summary_stat_groups"
    )
  }

  key_stats_names_data <-
    dplyr::select(
      .data = cleaned_key_stats_names,
      sheet, sheet_details, row, series_hierarchy, series
    )

  return(key_stats_names_data)
}

#' Extracts and formats the data from a horizontal statistical publication
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#' @param stat_pub_name the name of the statistical publication
#' @param sheet_str_detect the regex used to identify the sheets to extract
#' @param frequency the frequency of the statistical publication
#' @param series_hierarchy_fn a function to apply to the series_hierarchy data
#' @param series_hierarchy_args list of args to be passed to the function in
#' series_hierarchy_fn
#'
#' @keywords internal
#' @noRd
#'
format_horizontal_data <- function(tidyxl_data,
                                   formatting_data,
                                   stat_pub_name,
                                   sheet_str_detect,
                                   frequency,
                                   series_hierarchy_fn = NULL,
                                   series_hierarchy_args = NULL) {
  series_hierarchy_data <-
    get_series_hierarchy(
      tidyxl_data = tidyxl_data,
      formatting_data = formatting_data,
      sheet_str_detect = sheet_str_detect
    )

  if (!is.null(series_hierarchy_fn)) {
    series_hierarchy_data <-
      do.call(
        series_hierarchy_fn,
        c(list(series_hierarchy_data), series_hierarchy_args)
      )
  }

  relevant_tidyxl_data <-
    dplyr::filter(
      .data = tidyxl_data,
      stringr::str_detect(sheet, sheet_str_detect),
      data_type == "numeric" | character == "*" # APRA marks censored data by * rather than NA
    )

  relevant_tidyxl_data <-
    dplyr::select(
      .data = relevant_tidyxl_data,
      sheet, row, col, "value" = numeric
    )

  final_joined_data <-
    dplyr::left_join(
      x = relevant_tidyxl_data,
      y = series_hierarchy_data,
      by = dplyr::join_by(sheet, row)
    )

  tidyxl_number_formatting_data <-
    joined_formatting_data(tidyxl_data, formatting_data)

  final_joined_data <-
    dplyr::left_join(
      x = final_joined_data,
      y = tidyxl_number_formatting_data,
      by = dplyr::join_by(sheet, row, col)
    )

  dates_data <- get_horizontal_data_dates(tidyxl_data, sheet_str_detect)

  final_joined_data <-
    dplyr::left_join(
      x = final_joined_data,
      y = dates_data,
      by = dplyr::join_by(sheet, col),
      relationship = "many-to-one"
    )

  final_joined_data <- dplyr::filter(.data = final_joined_data, !is.na(date))

  final_joined_data <- clean_unit_data(final_joined_data)

  final_joined_data <-
    dplyr::select(
      .data = final_joined_data,
      date, sheet, sheet_details, series_hierarchy, series, unit, value
    )

  final_joined_data <-
    dplyr::mutate(
      .data = final_joined_data,
      frequency = frequency,
      .before = unit
    )

  final_joined_data <-
    dplyr::mutate(
      .data = final_joined_data,
      statistics_publication_name = stat_pub_name,
      .before = 1
    )

  return(final_joined_data)
}

#' Extracts the horizontal date data and cleans it
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param sheet_str_detect the regex used to identify the sheets to extract
#'
#' @keywords internal
#' @noRd
#'
get_horizontal_data_dates <- function(tidyxl_data, sheet_str_detect) {
  dates_data <-
    dplyr::mutate(
      .data = tidyxl_data,
      # if_else to convert non-date dates to dates.
      date = dplyr::if_else(
        condition = !is.na(character),
        true =
          lubridate::parse_date_time(
            x = character,
            orders = c("my", "ymd", "dmy"),
            quiet = TRUE
          ),
        false = date
      ),
      date = lubridate::as_date(date),
      date = lubridate::rollforward(date)
    )

  dates_data <-
    dplyr::filter(
      .data = dates_data,
      stringr::str_detect(sheet, sheet_str_detect),
      !grepl("year.*end|end.*year", character, ignore.case = TRUE),
      !is.na(date),
      col != 1
    )

  dates_data <-
    dplyr::distinct(dplyr::select(.data = dates_data, sheet, col, date))

  return(dates_data)
}

#' Safely get the QADIPS tab sheet data
#'
#' @keywords internal
#' @noRd
#'
safe_format_horizontal_data <- purrr::safely(format_horizontal_data)

#' Attempts to get the QADIPS Key Stats sheet data and if it encounters an error
#' it throws a warning and returns a empty tibble
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#' @param stat_pub_name the name of the statistical publication
#' @param sheet_str_detect the regex used to identify the sheets to extract
#' @param frequency the frequency of the statistical publication
#' @param series_hierarchy_fn a function to apply to the series_hierarchy data
#' @param series_hierarchy_args list of args to be passed to the function in
#' series_hierarchy_fn
#' @param error_or_warning whether to display an error or warning if safely fails
#' @param message the message to display in the message or warning.
#' @param call the caller environment
#'
#' @keywords internal
#' @noRd
#'
attempt_format_horizontal_data <- function(tidyxl_data,
                                           formatting_data,
                                           stat_pub_name,
                                           sheet_str_detect,
                                           frequency,
                                           series_hierarchy_fn = NULL,
                                           series_hierarchy_args = NULL,
                                           error_or_warning = "error",
                                           message = "The .xlsx file was in an unrecognised structure and could not be imported.",
                                           call = rlang::caller_env()) {
  rlang::arg_match(error_or_warning, c("error", "warning"))

  outcome <-
    safe_format_horizontal_data(
      tidyxl_data = tidyxl_data,
      formatting_data = formatting_data,
      stat_pub_name = stat_pub_name,
      sheet_str_detect = sheet_str_detect,
      frequency = frequency,
      series_hierarchy_fn = series_hierarchy_fn,
      series_hierarchy_args = series_hierarchy_args
    )

  if (!is.null(outcome$error)) {
    if (error_or_warning == "error") {
      cli::cli_abort(
        message = message,
        class = "readapra_error_horizontal_data_unreadable",
        call = call
      )
    } else {
      cli::cli_warn(
        message = message,
        class = "readapra_warning_horizontal_data_unreadable",
        call = call
      )
    }
  } else {
    return(outcome$result)
  }
}

#' Read Quarterly ADI Property Exposure Statistics
#'
#' @description
#' Import the Quarterly Authorised Deposit-taking Institution Property Exposure
#' Statistics (QPEXS) from a local file. Both the current and historic versions
#' of this statistical publication are available.
#'
#' @param file_path path to the local .xlsx file.
#' @param cur_hist character vector determining whether to download the current
#' publication (`"current"`) or the historic publication (`"historic"`).
#'
#' @return A tibble containing the Quarterly ADI Performance Statistics data.
#'
#' @noRd
#'
read_qadipexs <- function(file_path, cur_hist, call = rlang::caller_env()) {
  tidyxl_data <- read_tidyxl_data(file_path, call = call)
  formatting_data <- read_tidyxl_formatting_data(file_path)
  qadipexs_data(tidyxl_data, formatting_data, cur_hist, call = call)
}

#' Extracts the QADIPEXS data from the various sheets and conducts final
#' formatting tweaks
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#' @param cur_hist character vector determining whether to download the current
#' publication (`"current"`) or the historic publication (`"historic"`).
#' @param call the caller environment
#'
#' @keywords internal
#' @noRd
#'
qadipexs_data <- function(tidyxl_data,
                          formatting_data,
                          cur_hist,
                          call = rlang::caller_env()) {
  qadipexs_data <-
    attempt_format_horizontal_data(
      tidyxl_data = tidyxl_data,
      formatting_data = formatting_data,
      stat_pub_name = "Quarterly Authorised Deposit-taking Institution Property Exposures Statistics",
      sheet_str_detect = "Tab",
      frequency = "Quarterly",
      call = call
    )

  if (cur_hist == "current") {
    qadipexs_data <-
      dplyr::mutate(
        .data = qadipexs_data,
        unit = dplyr::case_when(
          series %in% c(
            "Impaired assets to exposures",
            "Specific provisions to exposures",
            "Specific provisions to impaired exposures",
            "Specific provisions and security held to impaired exposures",
            "Non-performing to total exposures",
            "Specific provisions to total exposures",
            "Specific provisions to non-performing exposures",
            "Specific provisions and security held to non-performing exposures",
            "Weighted average variable rate of new loans funded",
            "Weighted average assessment rate used for serviceability"
          )
          ~ "Percent",
          .default = unit
        )
      )
  }

  qadipexs_data <-
    replace_columns_patterns(
      data = qadipexs_data,
      cols = c("series_hierarchy", "series"),
      match = qadipexs_string_replacement$match,
      replace = qadipexs_string_replacement$replacement
    )

  return(qadipexs_data)
}

#' Malformed strings in the QADIPEXS that need replacing
#'
#' @noRd
#'
qadipexs_string_replacement <-
  tibble::tribble(
    ~match, ~replacement,
    "Number of entitiesa", "Number of entities",
    "Number of entitiesb", "Number of entities",
    "Impaired Commercial property exposuresa", "Impaired Commercial property exposures",
    "Specific provisions and securitya", "Specific provisions and security",
    "Impaired assets to exposuresa", "Impaired assets to exposures",
    "Specific provisions to exposuresa", "Specific provisions to exposures",
    "Specific provisions and security held to impaired exposuresa", "Specific provisions and security held to impaired exposures",
    "All ADIsb", "All ADIs",
    "of which:a", "of which:",
    "of which:b", "of which:",
    "of which:c", "of which:",
    "All other domestic banksa", "All other domestic banks",
    "All foreign subsidiary banksa", "All foreign subsidiary banks"
  )

#' Read Quarterly ADI Centralised Publication
#'
#' @description
#' Import the Quarterly Authorised Deposit-taking Institution Centralised
#' Publication (QADICP) from a local file.
#'
#' @param file_path path to the local .xlsx file.
#' @param cur_hist character vector determining whether to download the current
#' publication (`"current"`) or the historic publication (`"historic"`).
#'
#' @return A tibble containing the Quarterly ADI Centralised Publication data.
#'
#' @noRd
#'
read_qadicp <- function(file_path, cur_hist, call = rlang::caller_env()) {
  tidyxl_data <- read_tidyxl_data(file_path, "table.*4", call = call)
  formatting_data <- read_tidyxl_formatting_data(file_path)
  qadicp_data(tidyxl_data, formatting_data, call = call)
}

#' Combines the various QADICP data tibbles together alongside final formatting
#'
#' @param tidyxl_data cell data extracted from a .xlsx file using the tidyxl
#' package
#' @param formatting_data formatting data extracted from a .xlsx file using the
#' tidyxl package
#'
#' @noRd
#'
qadicp_data <- function(tidyxl_data,
                        formatting_data,
                        call = rlang::caller_env()) {
  qadicp_data <-
    attempt_format_vertical_data(
      tidyxl_data = tidyxl_data,
      formatting_data = formatting_data,
      stat_pub_name = "Quarterly Authorised Deposit-taking Institution Centralised Publication",
      frequency = "Quarterly",
      drop_col = FALSE,
      call = call
    )
  qadicp_data <- add_qadicp_regulatory_category(qadicp_data, call = call)
  qadicp_data <- dplyr::select(.data = qadicp_data, !col)
  qadicp_data <- convert_abn(qadicp_data)
  qadicp_data <-
    dplyr::arrange(
      .data = qadicp_data,
      date,
      entity,
      risk_metric_category,
      series
    )

  return(qadicp_data)
}

#' Adds a balance sheet category to the MADIS data. Certain MADIS series have
#' the same name, adding this column helps distinguish them.
#'
#' @param qadicp_data The cleaned qadicp data
#'
#' @keywords internal
#' @noRd
#'
add_qadicp_regulatory_category <- function(qadicp_data,
                                           call = rlang::caller_env()) {
  original_col <- qadicp_data$col
  qadicp_data$col <- qadicp_data$col - min(qadicp_data$col) + 1

  qadicp_data <-
    dplyr::left_join(
      x = qadicp_data,
      y = qadicp_risk_metric_category,
      by = dplyr::join_by("series", "col")
    )

  if (any(is.na(qadicp_data$risk_metric_category))) {
    cli::cli_warn(
      message = "Could not successfully attach contents of {.code risk_metric_category} column. The contents of this column are incomplete.",
      class = "readapra_warning_nas_in_qadicp_risk_metric_category"
    )
  }

  qadicp_data <- dplyr::relocate(
    .data = qadicp_data, risk_metric_category, .before = series
  )

  qadicp_data$col <- original_col

  return(qadicp_data)
}

test_that("read_qadicp() real download", {
  skip_if_offline()
  skip_on_cran()

  with_tempdir({
    qadicp_path <- download_apra("qadicp", "current", quiet = TRUE)
    qadicp_data <- read_qadicp(qadicp_path, "current")
    expect_s3_class(qadicp_data, "tbl_df")
    expect_equal(
      purrr::map(qadicp_data, class),
      list(
        statistics_publication_name = "character",
        date = "Date",
        abn = "numeric",
        entity = "character",
        entity_quarter_end = "Date",
        mutual_bank_y_n = "character",
        sector = "character",
        risk_metric_category = "character",
        series = "character",
        frequency = "character",
        unit = "character",
        value = "numeric"
      )
    )
  })
})

test_that("add_qadicp_regulatory_category() behaves as expected", {
  set.seed(123)
  qadicp_input_data <-
    tibble::tibble(
      date = as.Date("2024-12-31"),
      abn = 1111111,
      entity = "Entity A",
      series = qadicp_risk_metric_category$series,
      value = rnorm(17),
      col = 201:217
    )

  qadicp_output_data <-
    dplyr::mutate(
      .data = qadicp_input_data,
      risk_metric_category = qadicp_risk_metric_category$risk_metric_category,
      .before = series
    )

  # Standard test
  expect_equal(
    add_qadicp_regulatory_category(qadicp_input_data),
    qadicp_output_data
  )

  # Warning test
  qadicp_input_data$series <-
    dplyr::if_else(
      condition = qadicp_input_data$series == "Total Tier 1 capital",
      true = "Total T1 capital",
      false = qadicp_input_data$series
    )

  expect_warning(
    add_qadicp_regulatory_category(qadicp_input_data),
    class = "readapra_warning_nas_in_qadicp_risk_metric_category"
  )
})

#' Wrapper around read tidyxl's xlsx_cells() which can also extract specific sheets.
#'
#' @param file_path path to the file to import
#' @param sheets a regex string identifying which sheets to extract
#' @param number_sheets the expected number of sheets to be extracted
#'
#' @noRd
#'
read_tidyxl_data <- function(file_path,
                             sheets = NA,
                             number_sheets = 1,
                             call = rlang::caller_env()) {
  if (!is.na(sheets)) {
    sheet_names <- tidyxl::xlsx_sheet_names(file_path)
    sheets <- stringr::str_subset(sheet_names, stringr::regex(sheets, ignore_case = T))
    if (length(sheets) != number_sheets) {
      cli::cli_abort(
        message = c(
          "Could not extract data from the downloaded file.",
          c("x" = "Could not determine which sheet to extract data from.")
        ),
        class = "readapra_error_multiple_sheets_selected",
        call = call
      )
    }
  }

  tidyxl::xlsx_cells(
    path = file_path,
    check_filetype = TRUE,
    sheets = sheets,
    include_blank_cells = FALSE
  )
}

#' Wrapper around read tidyxl's xlsx_format()
#'
#' @param file_path Path to the downloaded xlsx file to import.
#'
#' @noRd
#'
read_tidyxl_formatting_data <- function(file_path) {
  tidyxl::xlsx_formats(file_path)
}

#' Wrapper of base Sys.sleep for testing purposes
#'
#' @noRd
#'
sys_sleep_wrapper <- function(time) {
  base::Sys.sleep(time = time)
}

#' Wrapper of base file.exists for testing purposes
#'
#' @keywords internal
#' @noRd
#'
file_exists_wrapper <- function(...) {
  base::file.exists(...)
}

#' Joins the formatting data with the standard data and uses this combined data
#' to construct a "get_series_hierarchy" variable.
#'
#' @param tidyxl_data The standard data sourced using read_tidyxl_data()
#' @param formatting_data The formatting data sourced using
#' read_tidyxl_formatting_data()
#' @param sheet_str_detect A string giving the excel sheet names to extract data
#' from
#'
#' @keywords internal
#' @noRd
#'
get_series_hierarchy <-
  function(tidyxl_data, formatting_data, sheet_str_detect) {
    indexed_formatting_data <-
      tibble::tibble(
        indent = formatting_data$local$alignment$indent,
        local_format_id = 1:length(formatting_data$local$alignment$indent)
      )

    series_hierarchy_data <-
      dplyr::left_join(tidyxl_data, indexed_formatting_data, "local_format_id")

    series_hierarchy_data <-
      dplyr::filter(
        .data = series_hierarchy_data,
        stringr::str_detect(sheet, sheet_str_detect), col == min(col)
      )

    series_hierarchy_data <-
      dplyr::select(
        .data = series_hierarchy_data,
        sheet, row, col, data_type, character, numeric, indent
      )

    series_hierarchy_data$character <-
      remove_escape_sequences(series_hierarchy_data$character)

    series_hierarchy_data <-
      dplyr::mutate(
        .data = series_hierarchy_data,
        which_identifier = dplyr::if_else(
          stringr::str_detect(character, "which"), 1, 0
        ),
        indent = dplyr::if_else(
          condition = stringr::str_detect(character, "^ +"),
          true = nchar(stringr::str_extract(character, "^ +")),
          false = indent
        ),
        character = dplyr::if_else(
          condition = stringr::str_detect(character, "^ +"),
          true = stringr::str_remove(character, "^ +"),
          false = character
        )
      )

    series_hierarchy_data <-
      dplyr::bind_rows(
        purrr::map(
          .x = split(series_hierarchy_data, series_hierarchy_data$sheet),
          .f = iterate_series_hierarchy
        )
      )

    series_hierarchy_data <-
      dplyr::arrange(
        .data = series_hierarchy_data,
        match(sheet, unique(series_hierarchy_data$sheet))
      )

    series_hierarchy_data <-
      dplyr::select(
        .data = series_hierarchy_data,
        sheet, sheet_details, row, series_hierarchy, series = character
      )

    return(series_hierarchy_data)
  }

#' Takes the data computed inside get_series_hierarchy() and iterates through
#' each row to work out the series hierarchy
#'
#' @param data data computed inside get_series_hierarchy()
#'
#' @keywords internal
#' @noRd
#'
iterate_series_hierarchy <- function(data) {
  data <- create_sheet_details_col(data)
  data <- adjust_indent(data)
  data <- dplyr::mutate(data, series_hierarchy = vector("list", dplyr::n()))

  for (i in seq_len(nrow(data))) {
    current_indent <- data$adjusted_indent[i]
    current_text <- data$character[i]

    if (current_indent == 0) {
      data$series_hierarchy[[i]] <- current_text
    } else {
      # Find the parent row
      parent_index <- max(which(data$adjusted_indent < current_indent & seq_len(nrow(data)) < i))
      parent_path <- data$series_hierarchy[[parent_index]]
      # Combine current text with its parent.
      if (stringr::str_detect(parent_path, ":$")) {
        data$series_hierarchy[[i]] <- paste(parent_path, current_text)
      } else {
        data$series_hierarchy[[i]] <- paste(parent_path, current_text, sep = "; ")
      }
    }
  }
  data$series_hierarchy <- unlist(data$series_hierarchy)
  return(data)
}

#' Creates a sheet_details column in the provided data based on the first row
#' of the character column
#'
#' @param data data to create the sheet_details column in.
#'
#' @keywords internal
#' @noRd
#'
create_sheet_details_col <- function(data) {
  data[["sheet_details"]] <- data$character[1]
  dplyr::relocate(.data = data, sheet_details, .after = sheet)
}

#' Combines the indent and which_identifier columns generated inside
#' get_series_hierarchy() to create an adjusted_indent column
#'
#' @param data data computed inside get_series_hierarchy()
#'
#' @keywords internal
#' @noRd
#'
adjust_indent <- function(data) {
  data$adjusted_indent <- data$indent
  for (i in seq_len(nrow(data))) {
    if (data$which_identifier[i] == 1) {
      # Increment the current "which" row's indent
      data$adjusted_indent[i] <- data$adjusted_indent[i] + 1
      # Propagate the increment to subsequent children
      for (j in (i + 1):nrow(data)) {
        if (data$indent[j] > data$indent[i]) {
          data$adjusted_indent[j] <- data$adjusted_indent[j] + 1
        } else {
          break
        }
      }
    }
  }
  return(data)
}

# check_valid_file_path() behaves as expected

    Code
      wrapper_check_valid_file_path("C:/Users/test_user/test_file.xlsx")
    Condition
      Error in `wrapper_check_valid_file_path()`:
      x No such file exists at: 'C:\Users\test_user\test_file.xlsx'.
      ! Please check you have specified the correct file path.

---

    Code
      wrapper_check_valid_file_path(data.frame())
    Condition
      Error in `wrapper_check_valid_file_path()`:
      ! `file_path` must be a <character> vector, not a <data.frame> object.

---

    Code
      wrapper_check_valid_file_path(1:5)
    Condition
      Error in `wrapper_check_valid_file_path()`:
      ! `file_path` must be a <character> vector, not a <integer> vector.

---

    Code
      wrapper_check_valid_file_path(c("test_a", "test_b"))
    Condition
      Error in `wrapper_check_valid_file_path()`:
      ! `file_path` must be a character vector of length 1, not length 2.

# check_logical_length_one() behaves as expected

    Code
      wrapper_check_logical_length_one(data.frame())
    Condition
      Error in `wrapper_check_logical_length_one()`:
      ! `data.frame()` must be a <logical> vector, not a <data.frame> object.

---

    Code
      wrapper_check_logical_length_one(1:5)
    Condition
      Error in `wrapper_check_logical_length_one()`:
      ! `1:5` must be a <logical> vector, not a <integer> vector.

---

    Code
      wrapper_check_logical_length_one(c(TRUE, FALSE, TRUE))
    Condition
      Error in `wrapper_check_logical_length_one()`:
      ! `c(TRUE, FALSE, TRUE)` must be a logical vector of length 1, not length 3.

# check_character_length_one() behaves as expected

    Code
      wrapper_check_character_length_one(data.frame())
    Condition
      Error in `wrapper_check_character_length_one()`:
      ! `data.frame()` must be a <character> vector, not a <data.frame> object.

---

    Code
      wrapper_check_character_length_one(1:5)
    Condition
      Error in `wrapper_check_character_length_one()`:
      ! `1:5` must be a <character> vector, not a <integer> vector.

---

    Code
      wrapper_check_character_length_one(c("test_a", "test_b"))
    Condition
      Error in `wrapper_check_character_length_one()`:
      ! `c("test_a", "test_b")` must be a character vector of length 1, not length 2.

# read_apra() error snapshots

    Code
      read_apra(stat_pub = "madi", cur_hist = "current")
    Condition
      Error in `read_apra()`:
      ! `stat_pub` must be an acronym of a statistical publication, not "madi".
      i Did you mean "madis"?
      i A list of valid acronyms is available in the `apra_stat_pubs` dataset.

---

    Code
      read_apra(stat_pub = data.frame(), cur_hist = "current")
    Condition
      Error in `read_apra()`:
      ! `stat_pub` must be a <character> vector, not a <data.frame> object.

---

    Code
      read_apra(stat_pub = 1:5, cur_hist = "current")
    Condition
      Error in `read_apra()`:
      ! `stat_pub` must be a <character> vector, not a <integer> vector.

---

    Code
      read_apra(stat_pub = c("madis", "current"), cur_hist = "current")
    Condition
      Error in `read_apra()`:
      ! `stat_pub` must be a character vector of length 1, not length 2.

---

    Code
      read_apra(stat_pub = "madi", cur_hist = "curren")
    Condition
      Error in `read_apra()`:
      ! `stat_pub` must be an acronym of a statistical publication, not "madi".
      i Did you mean "madis"?
      i A list of valid acronyms is available in the `apra_stat_pubs` dataset.

---

    Code
      read_apra(stat_pub = "madis", cur_hist = data.frame())
    Condition
      Error in `read_apra()`:
      ! `cur_hist` must be a <character> vector, not a <data.frame> object.

---

    Code
      read_apra(stat_pub = "madis", cur_hist = 1:5)
    Condition
      Error in `read_apra()`:
      ! `cur_hist` must be a <character> vector, not a <integer> vector.

---

    Code
      read_apra(stat_pub = "madis", cur_hist = c("current", "historic"))
    Condition
      Error in `read_apra()`:
      ! `cur_hist` must be a character vector of length 1, not length 2.

---

    Code
      read_apra(stat_pub = "madis", cur_hist = "current", quiet = data.frame())
    Condition
      Error in `read_apra()`:
      ! `quiet` must be a <logical> vector, not a <data.frame> object.

---

    Code
      read_apra(stat_pub = "madis", cur_hist = "current", quiet = "TRUE")
    Condition
      Error in `read_apra()`:
      ! `quiet` must be a <logical> vector, not a <character> vector.

---

    Code
      read_apra(stat_pub = "madis", cur_hist = "current", quiet = c(TRUE, TRUE))
    Condition
      Error in `read_apra()`:
      ! `quiet` must be a logical vector of length 1, not length 2.

---

    Code
      read_apra(stat_pub = "madis", cur_hist = "current", overwrite = data.frame())
    Condition
      Error in `read_apra()`:
      ! `overwrite` must be a <logical> vector, not a <data.frame> object.

---

    Code
      read_apra(stat_pub = "madis", cur_hist = "current", overwrite = "TRUE")
    Condition
      Error in `read_apra()`:
      ! `overwrite` must be a <logical> vector, not a <character> vector.

---

    Code
      read_apra(stat_pub = "madis", cur_hist = "current", overwrite = c(TRUE, TRUE))
    Condition
      Error in `read_apra()`:
      ! `overwrite` must be a logical vector of length 1, not length 2.

# read_apra_local() error snapshots

    Code
      read_apra_local(file_path = "C:/Users/test_user/test_file.xlsx", stat_pub = "madi",
        cur_hist = "current")
    Condition
      Error in `read_apra_local()`:
      x No such file exists at: 'C:\Users\test_user\test_file.xlsx'.
      ! Please check you have specified the correct file path.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/download_apra.R
\name{download_apra}
\alias{download_apra}
\title{Download a Statistical Publication File from APRA's Website}
\usage{
download_apra(
  stat_pub,
  cur_hist = "current",
  path = tempdir(),
  overwrite = TRUE,
  quiet = FALSE,
  ...
)
}
\arguments{
\item{stat_pub}{character vector detailing a statistical publication to be
downloaded. Must match a valid value in the
\code{apra_stat_pubs_acronym} variable of the \link{apra_stat_pubs} dataset.}

\item{cur_hist}{character vector detailing whether to download a current
or historic statistical publication. Must match a
valid value in the \code{cur_hist} variable of the \link{apra_stat_pubs}
dataset.}

\item{path}{path to where the downloaded file should be saved. Uses
\code{\link[base:tempfile]{base::tempdir()}} by default.}

\item{overwrite}{whether to overwrite a previously downloaded statistical
publication file when re-running this function.}

\item{quiet}{whether to suppress the download progress bar.}

\item{...}{additional arguments to be passed to \code{\link[utils:download.file]{utils::download.file()}}.}
}
\value{
A character vector detailing the file path to the downloaded file.
}
\description{
Download a statistical publication file from APRA's website. By
default files are saved to a temporary directory.
}
\examples{
\donttest{
# Download a statistical publication file:
download_path <-
  download_apra(stat_pub = "qadips", cur_hist = "current")

# View the file path of the statistical publication file:
print(download_path)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readapra_package.R
\docType{package}
\name{readapra-package}
\alias{readapra}
\alias{readapra-package}
\title{readapra: Download and Tidy Data from the Australian Prudential Regulation Authority}
\description{
Download the latest data from the Australian Prudential Regulation Authority \url{https://www.apra.gov.au/} and import it into R as a tidy data frame.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/javanderwal/readapra}
  \item \url{https://javanderwal.github.io/readapra/}
  \item Report bugs at \url{https://github.com/javanderwal/readapra/issues}
}

}
\author{
\strong{Maintainer}: Jarrod van der Wal \email{jarvanderwal@gmail.com} [copyright holder]

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{apra_stat_pubs}
\alias{apra_stat_pubs}
\title{Statistical Publications Produced by APRA}
\format{
A data frame with 7 rows and 3 variables:
\describe{
\item{stat_pub_name}{the full name of the statistical publication.}
\item{stat_pub_acronym}{the acronym of the statistical publication.}
\item{cur_hist}{available current and historical versions of the statistical publication.}
}
}
\usage{
apra_stat_pubs
}
\description{
This dataset contains a record of all statistical publications produced by
APRA that are available in \code{readapra}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_apra.R
\name{read_apra}
\alias{read_apra}
\title{Read APRA's Statistical Publications}
\usage{
read_apra(
  stat_pub,
  cur_hist = "current",
  path = tempdir(),
  quiet = FALSE,
  overwrite = TRUE,
  ...
)
}
\arguments{
\item{stat_pub}{character vector detailing a statistical publication to be
downloaded and imported. Must match a valid value in the
\code{apra_stat_pubs_acronym} variable of the \link{apra_stat_pubs} dataset.}

\item{cur_hist}{character vector detailing whether to download and import
a current or historic statistical publication. Must match a
valid value in the \code{cur_hist} variable of the \link{apra_stat_pubs}
dataset.}

\item{path}{path to where the downloaded file should be saved. Uses
\code{\link[base:tempfile]{base::tempdir()}} by default.}

\item{quiet}{whether to suppress the download progress bar.}

\item{overwrite}{whether to overwrite a previously downloaded statistical
publication file when re-running this function.}

\item{...}{additional arguments to be passed to \code{\link[utils:download.file]{utils::download.file()}}.}
}
\value{
A tibble containing the statistical publication data.
}
\description{
Download and import a specific statistical publication produced by APRA.

Please consult the \link{apra_stat_pubs} dataset to see which of APRA's
statistical publications are available in \code{readapra}.
}
\examples{
\donttest{
# Download and import the current MADIS data:
current_madis_data <-
  read_apra(stat_pub = "madis", cur_hist = "current")

# Examine the current MADIS data:
print(current_madis_data)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_apra.R
\name{read_apra_local}
\alias{read_apra_local}
\title{Read APRA Publication Statistics Locally}
\usage{
read_apra_local(file_path, stat_pub, cur_hist = "current")
}
\arguments{
\item{file_path}{path to the local file from which the statistical
publication data will be imported.}

\item{stat_pub}{character vector detailing a statistical publication to be
imported. Must match a valid value in the \code{apra_stat_pubs_acronym} variable
of the \link{apra_stat_pubs} dataset.}

\item{cur_hist}{character vector detailing whether to import a current
or historic statistical publication. Must match a
valid value in the \code{cur_hist} variable of the \link{apra_stat_pubs}
dataset.}
}
\value{
A tibble containing the statistical publication data.
}
\description{
Import from a local file a specific statistical publication produced by APRA.

Please consult the \link{apra_stat_pubs} dataset to see which of APRA's
statistical publications are available in \code{readapra}.
}
\examples{
\donttest{
# Download the current MADIS data and get the file path:
current_madis_file_path <-
  download_apra(stat_pub = "madis", cur_hist = "current")

# Import the current MADIS data:
current_madis_data <-
  read_apra_local(
    stat_pub = "madis",
    cur_hist = "current",
    file_path = current_madis_file_path
  )

# Examine the current MADIS data:
print(current_madis_data)
}

}
